(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('heatmap.js')) :
	typeof define === 'function' && define.amd ? define(['heatmap.js'], factory) :
	(global.fabricMapVue = factory(global.h337));
}(this, (function (h337) { 'use strict';

	h337 = h337 && h337.hasOwnProperty('default') ? h337['default'] : h337;

	var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

	function createCommonjsModule(fn, module) {
		return module = { exports: {} }, fn(module, module.exports), module.exports;
	}

	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
	  return typeof obj;
	} : function (obj) {
	  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
	};

	var asyncToGenerator = function (fn) {
	  return function () {
	    var gen = fn.apply(this, arguments);
	    return new Promise(function (resolve, reject) {
	      function step(key, arg) {
	        try {
	          var info = gen[key](arg);
	          var value = info.value;
	        } catch (error) {
	          reject(error);
	          return;
	        }

	        if (info.done) {
	          resolve(value);
	        } else {
	          return Promise.resolve(value).then(function (value) {
	            step("next", value);
	          }, function (err) {
	            step("throw", err);
	          });
	        }
	      }

	      return step("next");
	    });
	  };
	};

	var classCallCheck = function (instance, Constructor) {
	  if (!(instance instanceof Constructor)) {
	    throw new TypeError("Cannot call a class as a function");
	  }
	};

	var createClass = function () {
	  function defineProperties(target, props) {
	    for (var i = 0; i < props.length; i++) {
	      var descriptor = props[i];
	      descriptor.enumerable = descriptor.enumerable || false;
	      descriptor.configurable = true;
	      if ("value" in descriptor) descriptor.writable = true;
	      Object.defineProperty(target, descriptor.key, descriptor);
	    }
	  }

	  return function (Constructor, protoProps, staticProps) {
	    if (protoProps) defineProperties(Constructor.prototype, protoProps);
	    if (staticProps) defineProperties(Constructor, staticProps);
	    return Constructor;
	  };
	}();

	var _extends = Object.assign || function (target) {
	  for (var i = 1; i < arguments.length; i++) {
	    var source = arguments[i];

	    for (var key in source) {
	      if (Object.prototype.hasOwnProperty.call(source, key)) {
	        target[key] = source[key];
	      }
	    }
	  }

	  return target;
	};

	var get = function get(object, property, receiver) {
	  if (object === null) object = Function.prototype;
	  var desc = Object.getOwnPropertyDescriptor(object, property);

	  if (desc === undefined) {
	    var parent = Object.getPrototypeOf(object);

	    if (parent === null) {
	      return undefined;
	    } else {
	      return get(parent, property, receiver);
	    }
	  } else if ("value" in desc) {
	    return desc.value;
	  } else {
	    var getter = desc.get;

	    if (getter === undefined) {
	      return undefined;
	    }

	    return getter.call(receiver);
	  }
	};

	var inherits = function (subClass, superClass) {
	  if (typeof superClass !== "function" && superClass !== null) {
	    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
	  }

	  subClass.prototype = Object.create(superClass && superClass.prototype, {
	    constructor: {
	      value: subClass,
	      enumerable: false,
	      writable: true,
	      configurable: true
	    }
	  });
	  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
	};

	var objectWithoutProperties = function (obj, keys) {
	  var target = {};

	  for (var i in obj) {
	    if (keys.indexOf(i) >= 0) continue;
	    if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
	    target[i] = obj[i];
	  }

	  return target;
	};

	var possibleConstructorReturn = function (self, call) {
	  if (!self) {
	    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
	  }

	  return call && (typeof call === "object" || typeof call === "function") ? call : self;
	};

	var toConsumableArray = function (arr) {
	  if (Array.isArray(arr)) {
	    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

	    return arr2;
	  } else {
	    return Array.from(arr);
	  }
	};

	var runtime = createCommonjsModule(function (module) {
	  /**
	   * Copyright (c) 2014-present, Facebook, Inc.
	   *
	   * This source code is licensed under the MIT license found in the
	   * LICENSE file in the root directory of this source tree.
	   */

	  !function (global) {

	    var Op = Object.prototype;
	    var hasOwn = Op.hasOwnProperty;
	    var undefined; // More compressible than void 0.
	    var $Symbol = typeof Symbol === "function" ? Symbol : {};
	    var iteratorSymbol = $Symbol.iterator || "@@iterator";
	    var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
	    var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
	    var runtime = global.regeneratorRuntime;
	    if (runtime) {
	      {
	        // If regeneratorRuntime is defined globally and we're in a module,
	        // make the exports object identical to regeneratorRuntime.
	        module.exports = runtime;
	      }
	      // Don't bother evaluating the rest of this file if the runtime was
	      // already defined globally.
	      return;
	    }

	    // Define the runtime globally (as expected by generated code) as either
	    // module.exports (if we're in a module) or a new, empty object.
	    runtime = global.regeneratorRuntime = module.exports;

	    function wrap(innerFn, outerFn, self, tryLocsList) {
	      // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
	      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
	      var generator = Object.create(protoGenerator.prototype);
	      var context = new Context(tryLocsList || []);

	      // The ._invoke method unifies the implementations of the .next,
	      // .throw, and .return methods.
	      generator._invoke = makeInvokeMethod(innerFn, self, context);

	      return generator;
	    }
	    runtime.wrap = wrap;

	    // Try/catch helper to minimize deoptimizations. Returns a completion
	    // record like context.tryEntries[i].completion. This interface could
	    // have been (and was previously) designed to take a closure to be
	    // invoked without arguments, but in all the cases we care about we
	    // already have an existing method we want to call, so there's no need
	    // to create a new function object. We can even get away with assuming
	    // the method takes exactly one argument, since that happens to be true
	    // in every case, so we don't have to touch the arguments object. The
	    // only additional allocation required is the completion record, which
	    // has a stable shape and so hopefully should be cheap to allocate.
	    function tryCatch(fn, obj, arg) {
	      try {
	        return { type: "normal", arg: fn.call(obj, arg) };
	      } catch (err) {
	        return { type: "throw", arg: err };
	      }
	    }

	    var GenStateSuspendedStart = "suspendedStart";
	    var GenStateSuspendedYield = "suspendedYield";
	    var GenStateExecuting = "executing";
	    var GenStateCompleted = "completed";

	    // Returning this object from the innerFn has the same effect as
	    // breaking out of the dispatch switch statement.
	    var ContinueSentinel = {};

	    // Dummy constructor functions that we use as the .constructor and
	    // .constructor.prototype properties for functions that return Generator
	    // objects. For full spec compliance, you may wish to configure your
	    // minifier not to mangle the names of these two functions.
	    function Generator() {}
	    function GeneratorFunction() {}
	    function GeneratorFunctionPrototype() {}

	    // This is a polyfill for %IteratorPrototype% for environments that
	    // don't natively support it.
	    var IteratorPrototype = {};
	    IteratorPrototype[iteratorSymbol] = function () {
	      return this;
	    };

	    var getProto = Object.getPrototypeOf;
	    var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
	    if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
	      // This environment has a native %IteratorPrototype%; use it instead
	      // of the polyfill.
	      IteratorPrototype = NativeIteratorPrototype;
	    }

	    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
	    GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
	    GeneratorFunctionPrototype.constructor = GeneratorFunction;
	    GeneratorFunctionPrototype[toStringTagSymbol] = GeneratorFunction.displayName = "GeneratorFunction";

	    // Helper for defining the .next, .throw, and .return methods of the
	    // Iterator interface in terms of a single ._invoke method.
	    function defineIteratorMethods(prototype) {
	      ["next", "throw", "return"].forEach(function (method) {
	        prototype[method] = function (arg) {
	          return this._invoke(method, arg);
	        };
	      });
	    }

	    runtime.isGeneratorFunction = function (genFun) {
	      var ctor = typeof genFun === "function" && genFun.constructor;
	      return ctor ? ctor === GeneratorFunction ||
	      // For the native GeneratorFunction constructor, the best we can
	      // do is to check its .name property.
	      (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
	    };

	    runtime.mark = function (genFun) {
	      if (Object.setPrototypeOf) {
	        Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
	      } else {
	        genFun.__proto__ = GeneratorFunctionPrototype;
	        if (!(toStringTagSymbol in genFun)) {
	          genFun[toStringTagSymbol] = "GeneratorFunction";
	        }
	      }
	      genFun.prototype = Object.create(Gp);
	      return genFun;
	    };

	    // Within the body of any async function, `await x` is transformed to
	    // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
	    // `hasOwn.call(value, "__await")` to determine if the yielded value is
	    // meant to be awaited.
	    runtime.awrap = function (arg) {
	      return { __await: arg };
	    };

	    function AsyncIterator(generator) {
	      function invoke(method, arg, resolve, reject) {
	        var record = tryCatch(generator[method], generator, arg);
	        if (record.type === "throw") {
	          reject(record.arg);
	        } else {
	          var result = record.arg;
	          var value = result.value;
	          if (value && (typeof value === "undefined" ? "undefined" : _typeof(value)) === "object" && hasOwn.call(value, "__await")) {
	            return Promise.resolve(value.__await).then(function (value) {
	              invoke("next", value, resolve, reject);
	            }, function (err) {
	              invoke("throw", err, resolve, reject);
	            });
	          }

	          return Promise.resolve(value).then(function (unwrapped) {
	            // When a yielded Promise is resolved, its final value becomes
	            // the .value of the Promise<{value,done}> result for the
	            // current iteration. If the Promise is rejected, however, the
	            // result for this iteration will be rejected with the same
	            // reason. Note that rejections of yielded Promises are not
	            // thrown back into the generator function, as is the case
	            // when an awaited Promise is rejected. This difference in
	            // behavior between yield and await is important, because it
	            // allows the consumer to decide what to do with the yielded
	            // rejection (swallow it and continue, manually .throw it back
	            // into the generator, abandon iteration, whatever). With
	            // await, by contrast, there is no opportunity to examine the
	            // rejection reason outside the generator function, so the
	            // only option is to throw it from the await expression, and
	            // let the generator function handle the exception.
	            result.value = unwrapped;
	            resolve(result);
	          }, reject);
	        }
	      }

	      var previousPromise;

	      function enqueue(method, arg) {
	        function callInvokeWithMethodAndArg() {
	          return new Promise(function (resolve, reject) {
	            invoke(method, arg, resolve, reject);
	          });
	        }

	        return previousPromise =
	        // If enqueue has been called before, then we want to wait until
	        // all previous Promises have been resolved before calling invoke,
	        // so that results are always delivered in the correct order. If
	        // enqueue has not been called before, then it is important to
	        // call invoke immediately, without waiting on a callback to fire,
	        // so that the async generator function has the opportunity to do
	        // any necessary setup in a predictable way. This predictability
	        // is why the Promise constructor synchronously invokes its
	        // executor callback, and why async functions synchronously
	        // execute code before the first await. Since we implement simple
	        // async functions in terms of async generators, it is especially
	        // important to get this right, even though it requires care.
	        previousPromise ? previousPromise.then(callInvokeWithMethodAndArg,
	        // Avoid propagating failures to Promises returned by later
	        // invocations of the iterator.
	        callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
	      }

	      // Define the unified helper method that is used to implement .next,
	      // .throw, and .return (see defineIteratorMethods).
	      this._invoke = enqueue;
	    }

	    defineIteratorMethods(AsyncIterator.prototype);
	    AsyncIterator.prototype[asyncIteratorSymbol] = function () {
	      return this;
	    };
	    runtime.AsyncIterator = AsyncIterator;

	    // Note that simple async functions are implemented on top of
	    // AsyncIterator objects; they just return a Promise for the value of
	    // the final result produced by the iterator.
	    runtime.async = function (innerFn, outerFn, self, tryLocsList) {
	      var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList));

	      return runtime.isGeneratorFunction(outerFn) ? iter // If outerFn is a generator, return the full iterator.
	      : iter.next().then(function (result) {
	        return result.done ? result.value : iter.next();
	      });
	    };

	    function makeInvokeMethod(innerFn, self, context) {
	      var state = GenStateSuspendedStart;

	      return function invoke(method, arg) {
	        if (state === GenStateExecuting) {
	          throw new Error("Generator is already running");
	        }

	        if (state === GenStateCompleted) {
	          if (method === "throw") {
	            throw arg;
	          }

	          // Be forgiving, per 25.3.3.3.3 of the spec:
	          // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
	          return doneResult();
	        }

	        context.method = method;
	        context.arg = arg;

	        while (true) {
	          var delegate = context.delegate;
	          if (delegate) {
	            var delegateResult = maybeInvokeDelegate(delegate, context);
	            if (delegateResult) {
	              if (delegateResult === ContinueSentinel) continue;
	              return delegateResult;
	            }
	          }

	          if (context.method === "next") {
	            // Setting context._sent for legacy support of Babel's
	            // function.sent implementation.
	            context.sent = context._sent = context.arg;
	          } else if (context.method === "throw") {
	            if (state === GenStateSuspendedStart) {
	              state = GenStateCompleted;
	              throw context.arg;
	            }

	            context.dispatchException(context.arg);
	          } else if (context.method === "return") {
	            context.abrupt("return", context.arg);
	          }

	          state = GenStateExecuting;

	          var record = tryCatch(innerFn, self, context);
	          if (record.type === "normal") {
	            // If an exception is thrown from innerFn, we leave state ===
	            // GenStateExecuting and loop back for another invocation.
	            state = context.done ? GenStateCompleted : GenStateSuspendedYield;

	            if (record.arg === ContinueSentinel) {
	              continue;
	            }

	            return {
	              value: record.arg,
	              done: context.done
	            };
	          } else if (record.type === "throw") {
	            state = GenStateCompleted;
	            // Dispatch the exception by looping back around to the
	            // context.dispatchException(context.arg) call above.
	            context.method = "throw";
	            context.arg = record.arg;
	          }
	        }
	      };
	    }

	    // Call delegate.iterator[context.method](context.arg) and handle the
	    // result, either by returning a { value, done } result from the
	    // delegate iterator, or by modifying context.method and context.arg,
	    // setting context.delegate to null, and returning the ContinueSentinel.
	    function maybeInvokeDelegate(delegate, context) {
	      var method = delegate.iterator[context.method];
	      if (method === undefined) {
	        // A .throw or .return when the delegate iterator has no .throw
	        // method always terminates the yield* loop.
	        context.delegate = null;

	        if (context.method === "throw") {
	          if (delegate.iterator.return) {
	            // If the delegate iterator has a return method, give it a
	            // chance to clean up.
	            context.method = "return";
	            context.arg = undefined;
	            maybeInvokeDelegate(delegate, context);

	            if (context.method === "throw") {
	              // If maybeInvokeDelegate(context) changed context.method from
	              // "return" to "throw", let that override the TypeError below.
	              return ContinueSentinel;
	            }
	          }

	          context.method = "throw";
	          context.arg = new TypeError("The iterator does not provide a 'throw' method");
	        }

	        return ContinueSentinel;
	      }

	      var record = tryCatch(method, delegate.iterator, context.arg);

	      if (record.type === "throw") {
	        context.method = "throw";
	        context.arg = record.arg;
	        context.delegate = null;
	        return ContinueSentinel;
	      }

	      var info = record.arg;

	      if (!info) {
	        context.method = "throw";
	        context.arg = new TypeError("iterator result is not an object");
	        context.delegate = null;
	        return ContinueSentinel;
	      }

	      if (info.done) {
	        // Assign the result of the finished delegate to the temporary
	        // variable specified by delegate.resultName (see delegateYield).
	        context[delegate.resultName] = info.value;

	        // Resume execution at the desired location (see delegateYield).
	        context.next = delegate.nextLoc;

	        // If context.method was "throw" but the delegate handled the
	        // exception, let the outer generator proceed normally. If
	        // context.method was "next", forget context.arg since it has been
	        // "consumed" by the delegate iterator. If context.method was
	        // "return", allow the original .return call to continue in the
	        // outer generator.
	        if (context.method !== "return") {
	          context.method = "next";
	          context.arg = undefined;
	        }
	      } else {
	        // Re-yield the result returned by the delegate method.
	        return info;
	      }

	      // The delegate iterator is finished, so forget it and continue with
	      // the outer generator.
	      context.delegate = null;
	      return ContinueSentinel;
	    }

	    // Define Generator.prototype.{next,throw,return} in terms of the
	    // unified ._invoke helper method.
	    defineIteratorMethods(Gp);

	    Gp[toStringTagSymbol] = "Generator";

	    // A Generator should always return itself as the iterator object when the
	    // @@iterator function is called on it. Some browsers' implementations of the
	    // iterator prototype chain incorrectly implement this, causing the Generator
	    // object to not be returned from this call. This ensures that doesn't happen.
	    // See https://github.com/facebook/regenerator/issues/274 for more details.
	    Gp[iteratorSymbol] = function () {
	      return this;
	    };

	    Gp.toString = function () {
	      return "[object Generator]";
	    };

	    function pushTryEntry(locs) {
	      var entry = { tryLoc: locs[0] };

	      if (1 in locs) {
	        entry.catchLoc = locs[1];
	      }

	      if (2 in locs) {
	        entry.finallyLoc = locs[2];
	        entry.afterLoc = locs[3];
	      }

	      this.tryEntries.push(entry);
	    }

	    function resetTryEntry(entry) {
	      var record = entry.completion || {};
	      record.type = "normal";
	      delete record.arg;
	      entry.completion = record;
	    }

	    function Context(tryLocsList) {
	      // The root entry object (effectively a try statement without a catch
	      // or a finally block) gives us a place to store values thrown from
	      // locations where there is no enclosing try statement.
	      this.tryEntries = [{ tryLoc: "root" }];
	      tryLocsList.forEach(pushTryEntry, this);
	      this.reset(true);
	    }

	    runtime.keys = function (object) {
	      var keys = [];
	      for (var key in object) {
	        keys.push(key);
	      }
	      keys.reverse();

	      // Rather than returning an object with a next method, we keep
	      // things simple and return the next function itself.
	      return function next() {
	        while (keys.length) {
	          var key = keys.pop();
	          if (key in object) {
	            next.value = key;
	            next.done = false;
	            return next;
	          }
	        }

	        // To avoid creating an additional object, we just hang the .value
	        // and .done properties off the next function object itself. This
	        // also ensures that the minifier will not anonymize the function.
	        next.done = true;
	        return next;
	      };
	    };

	    function values(iterable) {
	      if (iterable) {
	        var iteratorMethod = iterable[iteratorSymbol];
	        if (iteratorMethod) {
	          return iteratorMethod.call(iterable);
	        }

	        if (typeof iterable.next === "function") {
	          return iterable;
	        }

	        if (!isNaN(iterable.length)) {
	          var i = -1,
	              next = function next() {
	            while (++i < iterable.length) {
	              if (hasOwn.call(iterable, i)) {
	                next.value = iterable[i];
	                next.done = false;
	                return next;
	              }
	            }

	            next.value = undefined;
	            next.done = true;

	            return next;
	          };

	          return next.next = next;
	        }
	      }

	      // Return an iterator with no values.
	      return { next: doneResult };
	    }
	    runtime.values = values;

	    function doneResult() {
	      return { value: undefined, done: true };
	    }

	    Context.prototype = {
	      constructor: Context,

	      reset: function reset(skipTempReset) {
	        this.prev = 0;
	        this.next = 0;
	        // Resetting context._sent for legacy support of Babel's
	        // function.sent implementation.
	        this.sent = this._sent = undefined;
	        this.done = false;
	        this.delegate = null;

	        this.method = "next";
	        this.arg = undefined;

	        this.tryEntries.forEach(resetTryEntry);

	        if (!skipTempReset) {
	          for (var name in this) {
	            // Not sure about the optimal order of these conditions:
	            if (name.charAt(0) === "t" && hasOwn.call(this, name) && !isNaN(+name.slice(1))) {
	              this[name] = undefined;
	            }
	          }
	        }
	      },

	      stop: function stop() {
	        this.done = true;

	        var rootEntry = this.tryEntries[0];
	        var rootRecord = rootEntry.completion;
	        if (rootRecord.type === "throw") {
	          throw rootRecord.arg;
	        }

	        return this.rval;
	      },

	      dispatchException: function dispatchException(exception) {
	        if (this.done) {
	          throw exception;
	        }

	        var context = this;
	        function handle(loc, caught) {
	          record.type = "throw";
	          record.arg = exception;
	          context.next = loc;

	          if (caught) {
	            // If the dispatched exception was caught by a catch block,
	            // then let that catch block handle the exception normally.
	            context.method = "next";
	            context.arg = undefined;
	          }

	          return !!caught;
	        }

	        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
	          var entry = this.tryEntries[i];
	          var record = entry.completion;

	          if (entry.tryLoc === "root") {
	            // Exception thrown outside of any try block that could handle
	            // it, so set the completion value of the entire function to
	            // throw the exception.
	            return handle("end");
	          }

	          if (entry.tryLoc <= this.prev) {
	            var hasCatch = hasOwn.call(entry, "catchLoc");
	            var hasFinally = hasOwn.call(entry, "finallyLoc");

	            if (hasCatch && hasFinally) {
	              if (this.prev < entry.catchLoc) {
	                return handle(entry.catchLoc, true);
	              } else if (this.prev < entry.finallyLoc) {
	                return handle(entry.finallyLoc);
	              }
	            } else if (hasCatch) {
	              if (this.prev < entry.catchLoc) {
	                return handle(entry.catchLoc, true);
	              }
	            } else if (hasFinally) {
	              if (this.prev < entry.finallyLoc) {
	                return handle(entry.finallyLoc);
	              }
	            } else {
	              throw new Error("try statement without catch or finally");
	            }
	          }
	        }
	      },

	      abrupt: function abrupt(type, arg) {
	        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
	          var entry = this.tryEntries[i];
	          if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
	            var finallyEntry = entry;
	            break;
	          }
	        }

	        if (finallyEntry && (type === "break" || type === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
	          // Ignore the finally entry if control is not jumping to a
	          // location outside the try/catch block.
	          finallyEntry = null;
	        }

	        var record = finallyEntry ? finallyEntry.completion : {};
	        record.type = type;
	        record.arg = arg;

	        if (finallyEntry) {
	          this.method = "next";
	          this.next = finallyEntry.finallyLoc;
	          return ContinueSentinel;
	        }

	        return this.complete(record);
	      },

	      complete: function complete(record, afterLoc) {
	        if (record.type === "throw") {
	          throw record.arg;
	        }

	        if (record.type === "break" || record.type === "continue") {
	          this.next = record.arg;
	        } else if (record.type === "return") {
	          this.rval = this.arg = record.arg;
	          this.method = "return";
	          this.next = "end";
	        } else if (record.type === "normal" && afterLoc) {
	          this.next = afterLoc;
	        }

	        return ContinueSentinel;
	      },

	      finish: function finish(finallyLoc) {
	        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
	          var entry = this.tryEntries[i];
	          if (entry.finallyLoc === finallyLoc) {
	            this.complete(entry.completion, entry.afterLoc);
	            resetTryEntry(entry);
	            return ContinueSentinel;
	          }
	        }
	      },

	      "catch": function _catch(tryLoc) {
	        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
	          var entry = this.tryEntries[i];
	          if (entry.tryLoc === tryLoc) {
	            var record = entry.completion;
	            if (record.type === "throw") {
	              var thrown = record.arg;
	              resetTryEntry(entry);
	            }
	            return thrown;
	          }
	        }

	        // The context.catch method must only be called with a location
	        // argument that corresponds to a known catch block.
	        throw new Error("illegal catch attempt");
	      },

	      delegateYield: function delegateYield(iterable, resultName, nextLoc) {
	        this.delegate = {
	          iterator: values(iterable),
	          resultName: resultName,
	          nextLoc: nextLoc
	        };

	        if (this.method === "next") {
	          // Deliberately forget the last sent value so that we don't
	          // accidentally pass it on to the delegate.
	          this.arg = undefined;
	        }

	        return ContinueSentinel;
	      }
	    };
	  }(
	  // In sloppy mode, unbound `this` refers to the global object, fallback to
	  // Function constructor if we're in global strict mode. That is sadly a form
	  // of indirect eval which violates Content Security Policy.
	  function () {
	    return this;
	  }() || Function("return this")());
	});

	var POINT_TYPE_ENUM = {
	  TEXT: 'text',
	  IMG: 'img',
	  AREA: 'area'
	};

	var OBJ_POINT = 'point';

	var ZOOM_TYPE = {
	  CANVAS: 1,
	  MAP: 2
	};

	/**
	 * lodash (Custom Build) <https://lodash.com/>
	 * Build: `lodash modularize exports="npm" -o ./`
	 * Copyright jQuery Foundation and other contributors <https://jquery.org/>
	 * Released under MIT license <https://lodash.com/license>
	 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
	 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
	 */

	/** Used as the `TypeError` message for "Functions" methods. */
	var FUNC_ERROR_TEXT = 'Expected a function';

	/** Used as references for various `Number` constants. */
	var NAN = 0 / 0;

	/** `Object#toString` result references. */
	var symbolTag = '[object Symbol]';

	/** Used to match leading and trailing whitespace. */
	var reTrim = /^\s+|\s+$/g;

	/** Used to detect bad signed hexadecimal string values. */
	var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;

	/** Used to detect binary string values. */
	var reIsBinary = /^0b[01]+$/i;

	/** Used to detect octal string values. */
	var reIsOctal = /^0o[0-7]+$/i;

	/** Built-in method references without a dependency on `root`. */
	var freeParseInt = parseInt;

	/** Detect free variable `global` from Node.js. */
	var freeGlobal = _typeof(commonjsGlobal) == 'object' && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;

	/** Detect free variable `self`. */
	var freeSelf = (typeof self === 'undefined' ? 'undefined' : _typeof(self)) == 'object' && self && self.Object === Object && self;

	/** Used as a reference to the global object. */
	var root = freeGlobal || freeSelf || Function('return this')();

	/** Used for built-in method references. */
	var objectProto = Object.prototype;

	/**
	 * Used to resolve the
	 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
	 * of values.
	 */
	var objectToString = objectProto.toString;

	/* Built-in method references for those with the same name as other `lodash` methods. */
	var nativeMax = Math.max,
	    nativeMin = Math.min;

	/**
	 * Gets the timestamp of the number of milliseconds that have elapsed since
	 * the Unix epoch (1 January 1970 00:00:00 UTC).
	 *
	 * @static
	 * @memberOf _
	 * @since 2.4.0
	 * @category Date
	 * @returns {number} Returns the timestamp.
	 * @example
	 *
	 * _.defer(function(stamp) {
	 *   console.log(_.now() - stamp);
	 * }, _.now());
	 * // => Logs the number of milliseconds it took for the deferred invocation.
	 */
	var now = function now() {
	  return root.Date.now();
	};

	/**
	 * Creates a debounced function that delays invoking `func` until after `wait`
	 * milliseconds have elapsed since the last time the debounced function was
	 * invoked. The debounced function comes with a `cancel` method to cancel
	 * delayed `func` invocations and a `flush` method to immediately invoke them.
	 * Provide `options` to indicate whether `func` should be invoked on the
	 * leading and/or trailing edge of the `wait` timeout. The `func` is invoked
	 * with the last arguments provided to the debounced function. Subsequent
	 * calls to the debounced function return the result of the last `func`
	 * invocation.
	 *
	 * **Note:** If `leading` and `trailing` options are `true`, `func` is
	 * invoked on the trailing edge of the timeout only if the debounced function
	 * is invoked more than once during the `wait` timeout.
	 *
	 * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
	 * until to the next tick, similar to `setTimeout` with a timeout of `0`.
	 *
	 * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
	 * for details over the differences between `_.debounce` and `_.throttle`.
	 *
	 * @static
	 * @memberOf _
	 * @since 0.1.0
	 * @category Function
	 * @param {Function} func The function to debounce.
	 * @param {number} [wait=0] The number of milliseconds to delay.
	 * @param {Object} [options={}] The options object.
	 * @param {boolean} [options.leading=false]
	 *  Specify invoking on the leading edge of the timeout.
	 * @param {number} [options.maxWait]
	 *  The maximum time `func` is allowed to be delayed before it's invoked.
	 * @param {boolean} [options.trailing=true]
	 *  Specify invoking on the trailing edge of the timeout.
	 * @returns {Function} Returns the new debounced function.
	 * @example
	 *
	 * // Avoid costly calculations while the window size is in flux.
	 * jQuery(window).on('resize', _.debounce(calculateLayout, 150));
	 *
	 * // Invoke `sendMail` when clicked, debouncing subsequent calls.
	 * jQuery(element).on('click', _.debounce(sendMail, 300, {
	 *   'leading': true,
	 *   'trailing': false
	 * }));
	 *
	 * // Ensure `batchLog` is invoked once after 1 second of debounced calls.
	 * var debounced = _.debounce(batchLog, 250, { 'maxWait': 1000 });
	 * var source = new EventSource('/stream');
	 * jQuery(source).on('message', debounced);
	 *
	 * // Cancel the trailing debounced invocation.
	 * jQuery(window).on('popstate', debounced.cancel);
	 */
	function debounce(func, wait, options) {
	  var lastArgs,
	      lastThis,
	      maxWait,
	      result,
	      timerId,
	      lastCallTime,
	      lastInvokeTime = 0,
	      leading = false,
	      maxing = false,
	      trailing = true;

	  if (typeof func != 'function') {
	    throw new TypeError(FUNC_ERROR_TEXT);
	  }
	  wait = toNumber(wait) || 0;
	  if (isObject(options)) {
	    leading = !!options.leading;
	    maxing = 'maxWait' in options;
	    maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
	    trailing = 'trailing' in options ? !!options.trailing : trailing;
	  }

	  function invokeFunc(time) {
	    var args = lastArgs,
	        thisArg = lastThis;

	    lastArgs = lastThis = undefined;
	    lastInvokeTime = time;
	    result = func.apply(thisArg, args);
	    return result;
	  }

	  function leadingEdge(time) {
	    // Reset any `maxWait` timer.
	    lastInvokeTime = time;
	    // Start the timer for the trailing edge.
	    timerId = setTimeout(timerExpired, wait);
	    // Invoke the leading edge.
	    return leading ? invokeFunc(time) : result;
	  }

	  function remainingWait(time) {
	    var timeSinceLastCall = time - lastCallTime,
	        timeSinceLastInvoke = time - lastInvokeTime,
	        result = wait - timeSinceLastCall;

	    return maxing ? nativeMin(result, maxWait - timeSinceLastInvoke) : result;
	  }

	  function shouldInvoke(time) {
	    var timeSinceLastCall = time - lastCallTime,
	        timeSinceLastInvoke = time - lastInvokeTime;

	    // Either this is the first call, activity has stopped and we're at the
	    // trailing edge, the system time has gone backwards and we're treating
	    // it as the trailing edge, or we've hit the `maxWait` limit.
	    return lastCallTime === undefined || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
	  }

	  function timerExpired() {
	    var time = now();
	    if (shouldInvoke(time)) {
	      return trailingEdge(time);
	    }
	    // Restart the timer.
	    timerId = setTimeout(timerExpired, remainingWait(time));
	  }

	  function trailingEdge(time) {
	    timerId = undefined;

	    // Only invoke if we have `lastArgs` which means `func` has been
	    // debounced at least once.
	    if (trailing && lastArgs) {
	      return invokeFunc(time);
	    }
	    lastArgs = lastThis = undefined;
	    return result;
	  }

	  function cancel() {
	    if (timerId !== undefined) {
	      clearTimeout(timerId);
	    }
	    lastInvokeTime = 0;
	    lastArgs = lastCallTime = lastThis = timerId = undefined;
	  }

	  function flush() {
	    return timerId === undefined ? result : trailingEdge(now());
	  }

	  function debounced() {
	    var time = now(),
	        isInvoking = shouldInvoke(time);

	    lastArgs = arguments;
	    lastThis = this;
	    lastCallTime = time;

	    if (isInvoking) {
	      if (timerId === undefined) {
	        return leadingEdge(lastCallTime);
	      }
	      if (maxing) {
	        // Handle invocations in a tight loop.
	        timerId = setTimeout(timerExpired, wait);
	        return invokeFunc(lastCallTime);
	      }
	    }
	    if (timerId === undefined) {
	      timerId = setTimeout(timerExpired, wait);
	    }
	    return result;
	  }
	  debounced.cancel = cancel;
	  debounced.flush = flush;
	  return debounced;
	}

	/**
	 * Checks if `value` is the
	 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
	 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
	 *
	 * @static
	 * @memberOf _
	 * @since 0.1.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
	 * @example
	 *
	 * _.isObject({});
	 * // => true
	 *
	 * _.isObject([1, 2, 3]);
	 * // => true
	 *
	 * _.isObject(_.noop);
	 * // => true
	 *
	 * _.isObject(null);
	 * // => false
	 */
	function isObject(value) {
	  var type = typeof value === 'undefined' ? 'undefined' : _typeof(value);
	  return !!value && (type == 'object' || type == 'function');
	}

	/**
	 * Checks if `value` is object-like. A value is object-like if it's not `null`
	 * and has a `typeof` result of "object".
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
	 * @example
	 *
	 * _.isObjectLike({});
	 * // => true
	 *
	 * _.isObjectLike([1, 2, 3]);
	 * // => true
	 *
	 * _.isObjectLike(_.noop);
	 * // => false
	 *
	 * _.isObjectLike(null);
	 * // => false
	 */
	function isObjectLike(value) {
	  return !!value && (typeof value === 'undefined' ? 'undefined' : _typeof(value)) == 'object';
	}

	/**
	 * Checks if `value` is classified as a `Symbol` primitive or object.
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
	 * @example
	 *
	 * _.isSymbol(Symbol.iterator);
	 * // => true
	 *
	 * _.isSymbol('abc');
	 * // => false
	 */
	function isSymbol(value) {
	  return (typeof value === 'undefined' ? 'undefined' : _typeof(value)) == 'symbol' || isObjectLike(value) && objectToString.call(value) == symbolTag;
	}

	/**
	 * Converts `value` to a number.
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to process.
	 * @returns {number} Returns the number.
	 * @example
	 *
	 * _.toNumber(3.2);
	 * // => 3.2
	 *
	 * _.toNumber(Number.MIN_VALUE);
	 * // => 5e-324
	 *
	 * _.toNumber(Infinity);
	 * // => Infinity
	 *
	 * _.toNumber('3.2');
	 * // => 3.2
	 */
	function toNumber(value) {
	  if (typeof value == 'number') {
	    return value;
	  }
	  if (isSymbol(value)) {
	    return NAN;
	  }
	  if (isObject(value)) {
	    var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
	    value = isObject(other) ? other + '' : other;
	  }
	  if (typeof value != 'string') {
	    return value === 0 ? value : +value;
	  }
	  value = value.replace(reTrim, '');
	  var isBinary = reIsBinary.test(value);
	  return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
	}

	var lodash_debounce = debounce;

	var raf = null;
	function requestAnimationFrame(callback) {
	  if (!raf) {
	    raf = (window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || function (callback) {
	      return setTimeout(callback, 16);
	    }).bind(window);
	  }
	  return raf(callback);
	}

	var caf = null;
	function cancelAnimationFrame(id) {
	  if (!caf) {
	    caf = (window.cancelAnimationFrame || window.webkitCancelAnimationFrame || window.mozCancelAnimationFrame || function (id) {
	      clearTimeout(id);
	    }).bind(window);
	  }

	  caf(id);
	}

	function createStyles(styleText) {
	  var style = document.createElement('style');
	  style.type = 'text/css';

	  if (style.styleSheet) {
	    style.styleSheet.cssText = styleText;
	  } else {
	    style.appendChild(document.createTextNode(styleText));
	  }
	  (document.querySelector('head') || document.body).appendChild(style);
	  return style;
	}

	function createElement(tagName) {
	  var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

	  var elem = document.createElement(tagName);
	  Object.keys(props).forEach(function (key) {
	    elem[key] = props[key];
	  });
	  return elem;
	}

	function getComputedStyle(elem, prop, pseudo) {
	  // for older versions of Firefox, `getComputedStyle` required
	  // the second argument and may return `null` for some elements
	  // when `display: none`
	  var computedStyle = window.getComputedStyle(elem, pseudo || null) || {
	    display: 'none'
	  };

	  return computedStyle[prop];
	}

	function getRenderInfo(elem) {
	  if (!document.documentElement.contains(elem)) {
	    return {
	      detached: true,
	      rendered: false
	    };
	  }

	  var current = elem;
	  while (current !== document) {
	    if (getComputedStyle(current, 'display') === 'none') {
	      return {
	        detached: false,
	        rendered: false
	      };
	    }
	    current = current.parentNode;
	  }

	  return {
	    detached: false,
	    rendered: true
	  };
	}

	var css = ".resize-triggers{visibility:hidden;opacity:0}.resize-contract-trigger,.resize-contract-trigger:before,.resize-expand-trigger,.resize-triggers{content:\"\";position:absolute;top:0;left:0;height:100%;width:100%;overflow:hidden}.resize-contract-trigger,.resize-expand-trigger{background:#eee;overflow:auto}.resize-contract-trigger:before{width:200%;height:200%}";

	var total = 0;
	var style = null;

	function addListener(elem, callback) {
	  if (!elem.__resize_mutation_handler__) {
	    elem.__resize_mutation_handler__ = handleMutation.bind(elem);
	  }

	  var listeners = elem.__resize_listeners__;

	  if (!listeners) {
	    elem.__resize_listeners__ = [];
	    if (window.ResizeObserver) {
	      var offsetWidth = elem.offsetWidth,
	          offsetHeight = elem.offsetHeight;

	      var ro = new ResizeObserver(function () {
	        if (!elem.__resize_observer_triggered__) {
	          elem.__resize_observer_triggered__ = true;
	          if (elem.offsetWidth === offsetWidth && elem.offsetHeight === offsetHeight) {
	            return;
	          }
	        }
	        runCallbacks(elem);
	      });

	      // initially display none won't trigger ResizeObserver callback

	      var _getRenderInfo = getRenderInfo(elem),
	          detached = _getRenderInfo.detached,
	          rendered = _getRenderInfo.rendered;

	      elem.__resize_observer_triggered__ = detached === false && rendered === false;
	      elem.__resize_observer__ = ro;
	      ro.observe(elem);
	    } else if (elem.attachEvent && elem.addEventListener) {
	      // targeting IE9/10
	      elem.__resize_legacy_resize_handler__ = function handleLegacyResize() {
	        runCallbacks(elem);
	      };
	      elem.attachEvent('onresize', elem.__resize_legacy_resize_handler__);
	      document.addEventListener('DOMSubtreeModified', elem.__resize_mutation_handler__);
	    } else {
	      if (!total) {
	        style = createStyles(css);
	      }
	      initTriggers(elem);

	      elem.__resize_rendered__ = getRenderInfo(elem).rendered;
	      if (window.MutationObserver) {
	        var mo = new MutationObserver(elem.__resize_mutation_handler__);
	        mo.observe(document, {
	          attributes: true,
	          childList: true,
	          characterData: true,
	          subtree: true
	        });
	        elem.__resize_mutation_observer__ = mo;
	      }
	    }
	  }

	  elem.__resize_listeners__.push(callback);
	  total++;
	}

	function removeListener(elem, callback) {
	  var listeners = elem.__resize_listeners__;
	  if (!listeners) {
	    return;
	  }

	  if (callback) {
	    listeners.splice(listeners.indexOf(callback), 1);
	  }

	  // no listeners exist, or removing all listeners
	  if (!listeners.length || !callback) {
	    // targeting IE9/10
	    if (elem.detachEvent && elem.removeEventListener) {
	      elem.detachEvent('onresize', elem.__resize_legacy_resize_handler__);
	      document.removeEventListener('DOMSubtreeModified', elem.__resize_mutation_handler__);
	      return;
	    }

	    if (elem.__resize_observer__) {
	      elem.__resize_observer__.unobserve(elem);
	      elem.__resize_observer__.disconnect();
	      elem.__resize_observer__ = null;
	    } else {
	      if (elem.__resize_mutation_observer__) {
	        elem.__resize_mutation_observer__.disconnect();
	        elem.__resize_mutation_observer__ = null;
	      }
	      elem.removeEventListener('scroll', handleScroll);
	      elem.removeChild(elem.__resize_triggers__.triggers);
	      elem.__resize_triggers__ = null;
	    }
	    elem.__resize_listeners__ = null;
	  }

	  if (! --total && style) {
	    style.parentNode.removeChild(style);
	  }
	}

	function getUpdatedSize(elem) {
	  var _elem$__resize_last__ = elem.__resize_last__,
	      width = _elem$__resize_last__.width,
	      height = _elem$__resize_last__.height;
	  var offsetWidth = elem.offsetWidth,
	      offsetHeight = elem.offsetHeight;

	  if (offsetWidth !== width || offsetHeight !== height) {
	    return {
	      width: offsetWidth,
	      height: offsetHeight
	    };
	  }
	  return null;
	}

	function handleMutation() {
	  // `this` denotes the scrolling element
	  var _getRenderInfo2 = getRenderInfo(this),
	      rendered = _getRenderInfo2.rendered,
	      detached = _getRenderInfo2.detached;

	  if (rendered !== this.__resize_rendered__) {
	    if (!detached && this.__resize_triggers__) {
	      resetTriggers(this);
	      this.addEventListener('scroll', handleScroll, true);
	    }
	    this.__resize_rendered__ = rendered;
	    runCallbacks(this);
	  }
	}

	function handleScroll() {
	  var _this = this;

	  // `this` denotes the scrolling element
	  resetTriggers(this);
	  if (this.__resize_raf__) {
	    cancelAnimationFrame(this.__resize_raf__);
	  }
	  this.__resize_raf__ = requestAnimationFrame(function () {
	    var updated = getUpdatedSize(_this);
	    if (updated) {
	      _this.__resize_last__ = updated;
	      runCallbacks(_this);
	    }
	  });
	}

	function runCallbacks(elem) {
	  if (!elem || !elem.__resize_listeners__) {
	    return;
	  }
	  elem.__resize_listeners__.forEach(function (callback) {
	    callback.call(elem);
	  });
	}

	function initTriggers(elem) {
	  var position = getComputedStyle(elem, 'position');
	  if (!position || position === 'static') {
	    elem.style.position = 'relative';
	  }

	  elem.__resize_old_position__ = position;
	  elem.__resize_last__ = {};

	  var triggers = createElement('div', {
	    className: 'resize-triggers'
	  });
	  var expand = createElement('div', {
	    className: 'resize-expand-trigger'
	  });
	  var expandChild = createElement('div');
	  var contract = createElement('div', {
	    className: 'resize-contract-trigger'
	  });
	  expand.appendChild(expandChild);
	  triggers.appendChild(expand);
	  triggers.appendChild(contract);
	  elem.appendChild(triggers);

	  elem.__resize_triggers__ = {
	    triggers: triggers,
	    expand: expand,
	    expandChild: expandChild,
	    contract: contract
	  };

	  resetTriggers(elem);
	  elem.addEventListener('scroll', handleScroll, true);

	  elem.__resize_last__ = {
	    width: elem.offsetWidth,
	    height: elem.offsetHeight
	  };
	}

	function resetTriggers(elem) {
	  var _elem$__resize_trigge = elem.__resize_triggers__,
	      expand = _elem$__resize_trigge.expand,
	      expandChild = _elem$__resize_trigge.expandChild,
	      contract = _elem$__resize_trigge.contract;

	  // batch read

	  var csw = contract.scrollWidth,
	      csh = contract.scrollHeight;
	  var eow = expand.offsetWidth,
	      eoh = expand.offsetHeight,
	      esw = expand.scrollWidth,
	      esh = expand.scrollHeight;

	  // batch write

	  contract.scrollLeft = csw;
	  contract.scrollTop = csh;
	  expandChild.style.width = eow + 1 + 'px';
	  expandChild.style.height = eoh + 1 + 'px';
	  expand.scrollLeft = esw;
	  expand.scrollTop = esh;
	}

	var fabricHeatmapMixin = {
	  props: {
	    heatmapOptions: {
	      type: Object,
	      default: function _default() {
	        return {};
	      }
	    },
	    heatmapMin: {
	      type: Number,
	      default: 0
	    },
	    heatmapMax: {
	      type: Number,
	      default: 100
	    },
	    heatmapData: {
	      type: Array,
	      default: function _default() {
	        return [];
	      }
	    },
	    heatmapRadiusZoom: {
	      type: Boolean,
	      default: false
	    },
	    heatmapClickDrawable: {
	      type: Boolean,
	      default: false
	    },
	    heatmapMoveDrawable: {
	      type: Boolean,
	      default: false
	    },
	    heatmapDrawValue: {
	      type: Number,
	      default: 1
	    }
	  },
	  computed: {
	    mHeatmapOptions: function mHeatmapOptions() {
	      return _extends({
	        radius: 40 }, this.heatmapOptions);
	    }
	  },
	  methods: {
	    // 在组件挂载的时候会被调用
	    initHeatMap: function initHeatMap() {
	      this.$heatmapEl = this.$el.querySelector('.canvas-container');
	      this.heatmap = h337.create({
	        container: this.$heatmapEl
	      });
	      addListener(this.$heatmapEl, this._handleHeatmapResize);
	      this.renderHeatmap();
	      this.canvas.on('mouse:up', this.handleCanvasMouseUpForHeatmap);
	      this.canvas.on('object:scaling', this.handleCanvasScalingForHeatmap);
	      this.canvas.on('mouse:move', this.handleCanvasMouseMoveForHeatmap);
	    },
	    _handleHeatmapResize: function _handleHeatmapResize() {
	      if (!this.$heatmapEl) return;
	      this.heatmap.configure(_extends({}, this.mHeatmapOptions, {
	        width: this.$heatmapEl.clientWidth,
	        height: this.$heatmapEl.clientHeight
	      }));
	    },
	    handleCanvasMouseUpForHeatmap: function handleCanvasMouseUpForHeatmap(opt) {
	      if (opt.target === this.svgMap) {
	        if (this.heatmapClickDrawable && this.heatmap && opt.pointer) {
	          // 根据坐标来判断，当前是处于拖动状态，还是点击状态
	          if (this.svgMap.left === this.mouseDownSvgMapPointer.left && this.svgMap.top === this.mouseDownSvgMapPointer.top) {
	            var _opt$pointer = opt.pointer,
	                x = _opt$pointer.x,
	                y = _opt$pointer.y;

	            this.requestCallAdd({ x: x, y: y });
	          }
	        }
	      }
	    },
	    handleCanvasScalingForHeatmap: function handleCanvasScalingForHeatmap(opt) {
	      if (opt.target === this.svgMap) {
	        this.renderHeatmap();
	      }
	    },
	    handleCanvasMouseMoveForHeatmap: function handleCanvasMouseMoveForHeatmap(opt) {
	      if (opt.target === this.svgMap) {
	        if (this.heatmapMoveDrawable && this.heatmap && opt.pointer) {
	          var _opt$pointer2 = opt.pointer,
	              x = _opt$pointer2.x,
	              y = _opt$pointer2.y;

	          this.requestCallAdd({ x: x, y: y });
	        }
	        this.renderHeatmap();
	      }
	    },

	    requestCallAdd: lodash_debounce(function () {
	      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
	          x = _ref.x,
	          y = _ref.y;

	      this.callAdd({ x: x, y: y });
	    }, 15),
	    callAdd: function callAdd() {
	      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
	          x = _ref2.x,
	          y = _ref2.y;

	      var _point2svgRelativeRat = this.point2svgRelativeRateInfo({ x: x, y: y }, true),
	          coordX = _point2svgRelativeRat.coordX,
	          coordY = _point2svgRelativeRat.coordY;

	      this.callFun('heatmapAddCb', { coordX: coordX, coordY: coordY, value: this.heatmapDrawValue });
	    },
	    renderHeatmap: function renderHeatmap() {
	      var _this = this;

	      var data = this.heatmapData.map(function (item) {
	        var _item$coordX = item.coordX,
	            coordX = _item$coordX === undefined ? 0 : _item$coordX,
	            _item$coordY = item.coordY,
	            coordY = _item$coordY === undefined ? 0 : _item$coordY,
	            radius = item.radius,
	            rest = objectWithoutProperties(item, ['coordX', 'coordY', 'radius']);

	        var _svgRateInfo2Point = _this.svgRateInfo2Point({ coordX: coordX, coordY: coordY }, true),
	            x = _svgRateInfo2Point.x,
	            y = _svgRateInfo2Point.y;

	        var _radius = radius || _this.mHeatmapOptions.radius;

	        // 热力图在缩放的时候是否能够跟随缩放，不会因缩放而导致热力集中或分散
	        if (_this.heatmapRadiusZoom && _this.svgMap && _this.canvas) {
	          if (_this.zoomType === ZOOM_TYPE.MAP) {
	            _radius = _radius * _this.svgMap.scaleX;
	          } else {
	            _radius = _radius * _this.canvas.getZoom();
	          }
	        }

	        return _extends({
	          x: x, y: y,
	          radius: _radius
	        }, rest);
	      });
	      this.heatmap && this.heatmap.setData({
	        max: this.heatmapMax,
	        min: this.heatmapMin,
	        data: data
	      });
	    },
	    heatmapAddData: function heatmapAddData(val) {
	      return this.heatmap && this.heatmap.addData(val);
	    },
	    heatmapGetValueAt: function heatmapGetValueAt(val) {
	      return this.heatmap && this.heatmap.getValueAt(val);
	    },
	    heatmapGetData: function heatmapGetData() {
	      return this.heatmap && this.heatmap.getData();
	    },
	    heatmapGetDataURL: function heatmapGetDataURL() {
	      return this.heatmap && this.heatmap.getDataURL();
	    },
	    heatmapRepaint: function heatmapRepaint() {
	      return this.heatmap && this.heatmap.repaint();
	    }
	  },
	  watch: {
	    heatmapData: function heatmapData() {
	      this.renderHeatmap();
	    },
	    heatmapRadiusZoom: function heatmapRadiusZoom() {
	      this.renderHeatmap();
	    },
	    mHeatmapOptions: function mHeatmapOptions(val) {
	      this.heatmap && this.heatmap.configure(val);
	    },
	    heatmapMin: function heatmapMin(val) {
	      this.heatmap && this.heatmap.setDataMin(val);
	    },
	    heatmapMax: function heatmapMax(val) {
	      this.heatmap && this.heatmap.setDataMax(val);
	    }
	  }
	};

	var DEFAULT_ZOOM_STEP = 0.1;

	var fabricZoom = {
	  props: {
	    maxZoom: {
	      type: Number,
	      default: 5
	    },
	    minZoom: {
	      type: Number,
	      default: 0.1
	    },
	    zoomRate: {
	      type: Number,
	      default: 1000
	    },
	    zoomType: {
	      type: Number,
	      default: ZOOM_TYPE.CANVAS
	    }
	  },
	  methods: {
	    initZoom: function initZoom() {
	      this.canvas.on('mouse:wheel', this.handleCanvasMousewheelForZoom);
	      this.canvas.on('object:scaling', this.handleCanvasObjectScalingForZoom);
	    },
	    handleCanvasObjectScalingForZoom: function handleCanvasObjectScalingForZoom(opt) {
	      if (!this.svgMap) return;
	      var zoom = this.zoomType === ZOOM_TYPE.MAP ? this.svgMap.scaleX : this.canvas.getZoom();
	      var _iteratorNormalCompletion = true;
	      var _didIteratorError = false;
	      var _iteratorError = undefined;

	      try {
	        for (var _iterator = this.svgMap.getObjects()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
	          var item = _step.value;

	          if (item.mType && item.mType === OBJ_POINT && item.mPointInfo) {
	            item.visible = !(item.mPointInfo.zoomThreshold && zoom < item.mPointInfo.zoomThreshold); // 缩小至某个值不显示
	          }
	        }
	      } catch (err) {
	        _didIteratorError = true;
	        _iteratorError = err;
	      } finally {
	        try {
	          if (!_iteratorNormalCompletion && _iterator.return) {
	            _iterator.return();
	          }
	        } finally {
	          if (_didIteratorError) {
	            throw _iteratorError;
	          }
	        }
	      }

	      this.canvas.requestRenderAll();
	    },
	    handleCanvasMousewheelForZoom: function handleCanvasMousewheelForZoom(opt) {
	      opt.e && opt.e.stopPropagation();
	      if (this.svgMap) {
	        var delta = opt.e.deltaY;
	        if (this.zoomType === ZOOM_TYPE.MAP) {
	          // svg scale, 缺点无法沿着鼠标点缩放，只能沿着originX,originY缩放
	          var scale = Number(this.svgMap.scaleX);
	          scale = scale + -(delta / this.zoomRate);
	          if (scale > this.maxZoom) scale = this.maxZoom;
	          if (scale < this.minZoom) scale = this.minZoom;
	          this.svgMap.scale(scale);
	          // svg scale end
	        } else {
	          // canvas zoom, 支持沿着中心点缩放
	          if (opt.target === this.svgMap) {
	            var zoom = this.canvas.getZoom();
	            zoom = zoom + -(delta / this.zoomRate);
	            if (zoom > this.maxZoom) zoom = this.maxZoom;
	            if (zoom < this.minZoom) zoom = this.minZoom;
	            this.canvas.zoomToPoint({ x: opt.e.offsetX, y: opt.e.offsetY }, zoom);
	          }
	        }
	        this.canvas.fire('object:scaling', { target: this.svgMap });
	        this.updatePointLine();
	        this.canvas.requestRenderAll();
	      }
	    },
	    handleZoomOutBtnClick: function handleZoomOutBtnClick() {
	      if (!this.svgMap) return;
	      if (this.activePoint) this.rememberRelationShip();
	      if (this.zoomType === ZOOM_TYPE.MAP) {
	        var scaleX = this.svgMap.scaleX;

	        this.svgMap.scale(Math.min(Number(scaleX) + DEFAULT_ZOOM_STEP, this.maxZoom));
	      } else {
	        this.canvas.setZoom(Math.min(Number(this.canvas.getZoom()) + DEFAULT_ZOOM_STEP, this.maxZoom));
	      }
	      this.canvas.fire('object:scaling', { target: this.svgMap });
	      this.updatePointLine();
	      this.canvas.requestRenderAll();
	    },
	    handleZoomInBtnClick: function handleZoomInBtnClick() {
	      if (!this.svgMap) return;
	      if (this.activePoint) this.rememberRelationShip();
	      if (this.zoomType === ZOOM_TYPE.MAP) {
	        var scaleX = this.svgMap.scaleX;

	        this.svgMap.scale(Math.max(Number(scaleX) - DEFAULT_ZOOM_STEP, 0.1));
	      } else {
	        this.canvas.setZoom(Math.max(Number(this.canvas.getZoom()) - DEFAULT_ZOOM_STEP, this.minZoom));
	      }
	      this.canvas.fire('object:scaling', { target: this.svgMap });
	      this.canvas.requestRenderAll();
	      this.updatePointLine();
	    }
	  }
	};

	var fabricAreaDistinguish = {
	  props: {
	    clickActiveFillColor: {
	      type: String,
	      default: 'red'
	    },
	    allowActiveAreaOnClick: {
	      type: Boolean,
	      default: false
	    }
	  },
	  methods: {
	    initAreaDistinguish: function initAreaDistinguish() {
	      this.canvas.on('mouse:down', this.handleCanvasMouseDownForAreaDistinguish);
	      this.canvas.on('mouse:up', this.handleCanvasMouseUpForAreaDistinguish);
	      this.canvas.on('mouse:dblclick', this.handleCanvasMouseDbClickForAreaDistinguish);
	    },
	    handleCanvasMouseDownForAreaDistinguish: function handleCanvasMouseDownForAreaDistinguish(opt) {
	      if (opt && opt.subTargets && opt.subTargets.length > 0) {
	        if (opt.subTargets[0].mType && opt.subTargets[0].mType === OBJ_POINT) {
	          this.$emit('pointClick', { info: opt.subTargets[0].mPointInfo }, opt.subTargets[0], opt);
	        } else {
	          this.$emit('areaClick', { id: opt.subTargets[0].id }, opt.subTargets[0], opt);
	        }
	        if (this.allowActiveAreaOnClick) {
	          this._distinguishTargetOriginInfo = {
	            fill: opt.subTargets[0].fill
	          };
	          opt.subTargets[0].set('fill', this.clickActiveFillColor);
	          this.canvas.requestRenderAll();
	        }
	      }
	    },
	    handleCanvasMouseUpForAreaDistinguish: function handleCanvasMouseUpForAreaDistinguish(opt) {
	      var _this = this;

	      if (opt && opt.subTargets && opt.subTargets.length > 0) {
	        Object.keys(this._distinguishTargetOriginInfo || {}).forEach(function (key) {
	          console.log(key, _this._distinguishTargetOriginInfo[key]);
	          opt.subTargets[0].set(key, _this._distinguishTargetOriginInfo[key]);
	        });
	        this._distinguishTargetOriginInfo = {};
	        this.canvas.requestRenderAll();
	      }
	    },
	    handleCanvasMouseDbClickForAreaDistinguish: function handleCanvasMouseDbClickForAreaDistinguish(opt) {
	      if (opt && opt.subTargets && opt.subTargets.length > 0) {
	        if (opt.subTargets[0].mType && opt.subTargets[0].mType === OBJ_POINT) {
	          this.$emit('pointDbClick', { info: opt.subTargets[0].mPointInfo }, opt.subTargets[0], opt);
	        } else {
	          this.$emit('areaDbClick', { id: opt.subTargets[0].id }, opt.subTargets[0], opt);
	        }
	      }
	    }
	  }
	};

	var DEFAULT_OPTIONS = {
	  selectable: false,
	  strokeWidth: 2,
	  evented: false,
	  stroke: 'red',
	  text: '',
	  textStyle: 'red'
	  // strokeDashArray: [5, 5],
	};

	var FabricArrowLine = function (_fabric$Line) {
	  inherits(FabricArrowLine, _fabric$Line);

	  function FabricArrowLine(points) {
	    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
	    classCallCheck(this, FabricArrowLine);
	    return possibleConstructorReturn(this, (FabricArrowLine.__proto__ || Object.getPrototypeOf(FabricArrowLine)).call(this, points, _extends({}, DEFAULT_OPTIONS, options)));
	  }
	  // 获取线的长度


	  createClass(FabricArrowLine, [{
	    key: 'getLength',
	    value: function getLength() {
	      var p = this.calcLinePoints();
	      var xDiff = p.x2 - p.x1;
	      var yDiff = p.y2 - p.y1;
	      return Math.sqrt(Math.pow(xDiff, 2) + Math.pow(yDiff, 2));
	    }
	  }, {
	    key: '_render',
	    value: function _render(ctx) {
	      get(FabricArrowLine.prototype.__proto__ || Object.getPrototypeOf(FabricArrowLine.prototype), '_render', this).call(this, ctx);
	      // 若果不显示或者坐标是一个点就不画箭头和文字
	      var p = this.calcLinePoints();
	      var xDiff = p.x2 - p.x1;
	      var yDiff = p.y2 - p.y1;
	      if (!this.visible || !xDiff && !yDiff) return;

	      var angle = Math.atan2(yDiff, xDiff);

	      ctx.strokeStyle = this.stroke;
	      if (this.strokeDashArray) {
	        ctx.setLineDash(this.strokeDashArray);
	      }

	      // 画开始箭头
	      ctx.save();
	      ctx.translate((p.x2 - p.x1) / 2, (p.y2 - p.y1) / 2);
	      ctx.rotate(angle);
	      ctx.moveTo(-8, 8);
	      ctx.lineTo(0, 0);
	      ctx.lineTo(-8, -8);
	      ctx.stroke();
	      ctx.restore();

	      // 画结束箭头
	      ctx.save();
	      ctx.translate(-(p.x2 - p.x1) / 2, -(p.y2 - p.y1) / 2);
	      ctx.rotate(angle);
	      ctx.moveTo(8, 8);
	      ctx.lineTo(0, 0);
	      ctx.lineTo(8, -8);
	      ctx.stroke();
	      ctx.restore();
	      // 添加文字
	      ctx.save();
	      // 保证文字从左至右，且下到上
	      ctx.rotate(xDiff > 0 ? Math.atan2(yDiff, xDiff) : Math.atan2(-yDiff, -xDiff));

	      // 绘制文字，放在点的起始位置
	      ctx.fillStyle = this.textStyle;
	      ctx.textAlign = xDiff <= 0 ? 'left' : 'right';
	      ctx.fillText(this.text, 0, -10);
	      ctx.restore();
	    }
	  }]);
	  return FabricArrowLine;
	}(fabric.Line);

	var fabricPointLine = {
	  props: {
	    mapWidth: {
	      type: Number,
	      default: 0
	    },
	    mapHeight: {
	      type: Number,
	      default: 0
	    },
	    mapUnit: {
	      type: String,
	      default: 'm'
	    },
	    showLine: {
	      type: Boolean,
	      default: false
	    }
	  },
	  methods: {
	    // 在组件挂载的时候会被调用
	    initPointLine: function initPointLine() {
	      this.lineX = new FabricArrowLine([0, 0, 0, 0]);
	      this.lineY = new FabricArrowLine([0, 0, 0, 0]);
	      this.linxRightX = new FabricArrowLine([0, 0, 0, 0]);
	      this.linxRightY = new FabricArrowLine([0, 0, 0, 0]);

	      this.canvas.add(this.lineX);
	      this.canvas.add(this.lineY);
	      this.canvas.add(this.linxRightX);
	      this.canvas.add(this.linxRightY);
	    },
	    updateLine: function updateLine(point, isPointInGroup) {
	      var _this = this;

	      if (!this.showLine) {
	        return this.clearLine();
	      }

	      var svgMap = this.svgMap;
	      var self = this;
	      var left = svgMap.left,
	          top = svgMap.top;

	      var scaledWidth = svgMap.getScaledWidth();
	      var scaleHeight = svgMap.getScaledHeight();

	      // 如果是点在group中的，就需要进行坐标转换
	      if (isPointInGroup) {
	        var newPoint = this.svgMap2CanvasPoint({ x: point.left, y: point.top });
	        point = { left: newPoint.x, top: newPoint.y };
	      }

	      // 查找包括住基站点的块
	      var wrapperObjs = [];
	      svgMap.forEachObject(function (item) {
	        // 过滤基站点
	        if (item.mType && item.mType === OBJ_POINT) return;
	        // 画一个点线，用这个电线判断是否在图形中
	        var testPoint = new fabric.Line([point.left, point.top, point.left, point.top]);
	        // 坐标转换 计算出块的范围
	        var scaledWidth = item.width * svgMap.scaleX;
	        var scaleHeight = item.height * svgMap.scaleY;
	        var newPoint = _this.svgMap2CanvasPoint({ x: item.left, y: item.top });
	        var pointBR = new fabric.Point(newPoint.x + scaledWidth, newPoint.y + scaleHeight);
	        if (testPoint.isContainedWithinRect(newPoint, pointBR)) {
	          wrapperObjs.push(item);
	        }
	      });

	      // 根据块的宽度，来取最近包围的块
	      var minObj = wrapperObjs.reduce(function (min, item) {
	        if (!min) return item;
	        if (item.width < min.width) {
	          min = item;
	        }
	        return min;
	      }, undefined);

	      // 如果有最近包含的块，设置划线的作用域块
	      if (minObj) {
	        var _newPoint = this.svgMap2CanvasPoint({ x: minObj.left, y: minObj.top });
	        left = _newPoint.x;
	        top = _newPoint.y;
	        scaledWidth = minObj.width * svgMap.scaleX;
	        scaleHeight = minObj.height * svgMap.scaleY;
	      }

	      var mapWidth = this.mapWidth;
	      var mapHeight = this.mapHeight;
	      var mapUnit = this.mapUnit;

	      // 划线
	      self.lineX.set({ x1: left, y1: point.top, x2: point.left, y2: point.top });
	      self.lineY.set({ x1: point.left, y1: top, x2: point.left, y2: point.top });
	      self.linxRightX.set({ x2: point.left, y2: point.top, x1: left + scaledWidth, y1: point.top });
	      self.linxRightY.set({ x2: point.left, y2: point.top, x1: point.left, y1: top + scaleHeight });
	      // 设置线的text X
	      var lineXText = (self.lineX.getLength() / this.svgMap.getScaledWidth() * mapHeight).toFixed(2);
	      self.lineX.text = lineXText ? '' + lineXText + mapUnit : '';
	      // 设置线的text  Y
	      var lineYText = (self.lineY.getLength() / this.svgMap.getScaledHeight() * mapWidth).toFixed(2);
	      self.lineY.text = lineYText ? '' + lineYText + mapUnit : '';
	      // 设置线的text RX
	      var lineRXText = (self.linxRightX.getLength() / this.svgMap.getScaledWidth() * mapHeight).toFixed(2);
	      self.linxRightX.text = lineRXText ? '' + lineRXText + mapUnit : '';
	      // 设置线的text  RY
	      var lineRYText = (self.linxRightY.getLength() / this.svgMap.getScaledHeight() * mapWidth).toFixed(2);
	      self.linxRightY.text = lineRYText ? '' + lineRYText + mapUnit : '';

	      self.lineX.setCoords();
	      self.lineY.setCoords();
	      self.linxRightX.setCoords();
	      self.linxRightY.setCoords();
	      self.canvas.discardActiveObject();
	      self.canvas.bringToFront(self.lineX);
	      self.canvas.bringToFront(self.lineY);
	      self.canvas.bringToFront(self.linxRightX);
	      self.canvas.bringToFront(self.linxRightY);
	      self.canvas.requestRenderAll();
	    },
	    clearLine: function clearLine() {
	      var self = this;
	      self.lineX.set({ x1: 0, y1: 0, x2: 0, y2: 0 });
	      self.lineY.set({ x1: 0, y1: 0, x2: 0, y2: 0 });
	      self.linxRightX.set({ x1: 0, y1: 0, x2: 0, y2: 0 });
	      self.linxRightY.set({ x1: 0, y1: 0, x2: 0, y2: 0 });
	      self.lineX.setCoords();
	      self.lineY.setCoords();
	      self.linxRightX.setCoords();
	      self.linxRightY.setCoords();
	      self.canvas.requestRenderAll();
	    },
	    updatePointLine: function updatePointLine() {
	      this.updateActivePointLine();
	      this.updateSelectedPointLine();
	    },
	    updateActivePointLine: function updateActivePointLine() {
	      if (this.activePoint) {
	        this.activePoint.scale(this.svgMap.scaleX); // 随着地图的方法缩放而缩放
	        this.updateLine(this.activePoint);
	      }
	    },
	    updateSelectedPointLine: function updateSelectedPointLine() {
	      if (this.selectedPoint) {
	        this.updateLine(this.selectedPoint, true);
	      }
	    }
	  },
	  watch: {
	    mapWidth: function mapWidth() {
	      this.updatePointLine();
	      this.canvas && this.canvas.requestRenderAll();
	    },
	    mapHeight: function mapHeight() {
	      this.updatePointLine();
	      this.canvas && this.canvas.requestRenderAll();
	    },
	    mapUnit: function mapUnit() {
	      this.updatePointLine();
	      this.canvas && this.canvas.requestRenderAll();
	    }
	  }
	};

	var FabricResizableCavas = function (_fabric$Canvas) {
	  inherits(FabricResizableCavas, _fabric$Canvas);

	  function FabricResizableCavas(el) {
	    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
	    classCallCheck(this, FabricResizableCavas);

	    var _this = possibleConstructorReturn(this, (FabricResizableCavas.__proto__ || Object.getPrototypeOf(FabricResizableCavas)).call(this, el, options));

	    var parentEl = options.parentEl;

	    _this.parentEl = parentEl;
	    if (parentEl) {
	      var resizeCanvas = function resizeCanvas() {
	        _this.setHeight(parentEl.clientHeight);
	        _this.setWidth(parentEl.clientWidth);
	        _this.requestRenderAll();
	      };
	      addListener(parentEl, function () {
	        resizeCanvas();
	      });
	      resizeCanvas();
	    }
	    return _this;
	  }

	  createClass(FabricResizableCavas, [{
	    key: 'destroy',
	    value: function destroy() {
	      this.parentEl && removeListener(this.parentEl);
	    }
	  }]);
	  return FabricResizableCavas;
	}(fabric.Canvas);

	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//

	var script = {
	  methods: {
	    handleDirBtnClick: function handleDirBtnClick(type) {
	      this.$emit('change', type);
	    }
	  }
	};

	/* script */
	var __vue_script__ = script;

	/* template */
	var __vue_render__ = function __vue_render__() {
	  var _vm = this;
	  var _h = _vm.$createElement;
	  var _c = _vm._self._c || _h;
	  return _c("div", { staticClass: "fm-dir-btn-wrapper" }, [_c("div", { staticClass: "fm-row" }, [_c("i", {
	    staticClass: "fm-icon-up-circle",
	    on: {
	      click: function click($event) {
	        _vm.handleDirBtnClick("up");
	      }
	    }
	  })]), _vm._v(" "), _c("div", { staticClass: "fm-row" }, [_c("i", {
	    staticClass: "fm-icon-left-circle",
	    on: {
	      click: function click($event) {
	        _vm.handleDirBtnClick("left");
	      }
	    }
	  }), _vm._v(" "), _c("i", {
	    staticClass: "fm-icon-right-circle",
	    on: {
	      click: function click($event) {
	        _vm.handleDirBtnClick("right");
	      }
	    }
	  })]), _vm._v(" "), _c("div", { staticClass: "fm-row" }, [_c("i", {
	    staticClass: "fm-icon-down-circle",
	    on: {
	      click: function click($event) {
	        _vm.handleDirBtnClick("down");
	      }
	    }
	  })])]);
	};
	var __vue_staticRenderFns__ = [];
	__vue_render__._withStripped = true;

	/* style */
	var __vue_inject_styles__ = function __vue_inject_styles__(inject) {
	  if (!inject) return;
	  inject("data-v-1a68f502_0", { source: "\n/*# sourceMappingURL=dir-btn.vue.map */", map: { "version": 3, "sources": ["dir-btn.vue"], "names": [], "mappings": ";AACA,uCAAuC", "file": "dir-btn.vue" }, media: undefined });
	};
	/* scoped */
	var __vue_scope_id__ = undefined;
	/* module identifier */
	var __vue_module_identifier__ = undefined;
	/* functional template */
	var __vue_is_functional_template__ = false;
	/* component normalizer */
	function __vue_normalize__(template, style, script$$1, scope, functional, moduleIdentifier, createInjector, createInjectorSSR) {
	  var component = (typeof script$$1 === 'function' ? script$$1.options : script$$1) || {};

	  // For security concerns, we use only base name in production mode.
	  component.__file = "D:\\Workspaces\\fabirc-map-vue\\src\\components\\fabric-map-vue\\dir-btn.vue";

	  if (!component.render) {
	    component.render = template.render;
	    component.staticRenderFns = template.staticRenderFns;
	    component._compiled = true;

	    if (functional) component.functional = true;
	  }

	  component._scopeId = scope;

	  {
	    var hook = void 0;
	    if (style) {
	      hook = function hook(context) {
	        style.call(this, createInjector(context));
	      };
	    }

	    if (hook !== undefined) {
	      if (component.functional) {
	        // register for functional component in vue file
	        var originalRender = component.render;
	        component.render = function renderWithStyleInjection(h, context) {
	          hook.call(context);
	          return originalRender(h, context);
	        };
	      } else {
	        // inject component registration as beforeCreate hook
	        var existing = component.beforeCreate;
	        component.beforeCreate = existing ? [].concat(existing, hook) : [hook];
	      }
	    }
	  }

	  return component;
	}
	/* style inject */
	function __vue_create_injector__() {
	  var head = document.head || document.getElementsByTagName('head')[0];
	  var styles = __vue_create_injector__.styles || (__vue_create_injector__.styles = {});
	  var isOldIE = typeof navigator !== 'undefined' && /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());

	  return function addStyle(id, css) {
	    if (document.querySelector('style[data-vue-ssr-id~="' + id + '"]')) return; // SSR styles are present.

	    var group = isOldIE ? css.media || 'default' : id;
	    var style = styles[group] || (styles[group] = { ids: [], parts: [], element: undefined });

	    if (!style.ids.includes(id)) {
	      var code = css.source;
	      var index = style.ids.length;

	      style.ids.push(id);

	      if (isOldIE) {
	        style.element = style.element || document.querySelector('style[data-group=' + group + ']');
	      }

	      if (!style.element) {
	        var el = style.element = document.createElement('style');
	        el.type = 'text/css';

	        if (css.media) el.setAttribute('media', css.media);
	        if (isOldIE) {
	          el.setAttribute('data-group', group);
	          el.setAttribute('data-next-index', '0');
	        }

	        head.appendChild(el);
	      }

	      if (isOldIE) {
	        index = parseInt(style.element.getAttribute('data-next-index'));
	        style.element.setAttribute('data-next-index', index + 1);
	      }

	      if (style.element.styleSheet) {
	        style.parts.push(code);
	        style.element.styleSheet.cssText = style.parts.filter(Boolean).join('\n');
	      } else {
	        var textNode = document.createTextNode(code);
	        var nodes = style.element.childNodes;
	        if (nodes[index]) style.element.removeChild(nodes[index]);
	        if (nodes.length) style.element.insertBefore(textNode, nodes[index]);else style.element.appendChild(textNode);
	      }
	    }
	  };
	}
	/* style inject SSR */

	var DirBtn = __vue_normalize__({ render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ }, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, __vue_create_injector__, undefined);

	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//

	var script$1 = {
	  props: {
	    width: {
	      type: String,
	      default: '50%'
	    },
	    minHeight: {
	      type: String,
	      default: '100px'
	    },
	    visible: {
	      type: Boolean,
	      default: false
	    }
	  },
	  methods: {
	    handleCloseBtnClick: function handleCloseBtnClick() {
	      this.$emit('update:visible', false);
	      this.$emit('close');
	    }
	  }
	};

	/* script */
	var __vue_script__$1 = script$1;

	/* template */
	var __vue_render__$1 = function __vue_render__() {
	  var _vm = this;
	  var _h = _vm.$createElement;
	  var _c = _vm._self._c || _h;
	  return _c("div", {
	    directives: [{
	      name: "show",
	      rawName: "v-show",
	      value: _vm.visible,
	      expression: "visible"
	    }]
	  }, [_c("div", { staticClass: "fm-dialog" }, [_c("div", {
	    staticClass: "fm-dialog-content",
	    style: { width: _vm.width, "min-height": _vm.minHeight }
	  }, [_c("div", {
	    staticClass: "fm-dialog-close-btn",
	    on: {
	      click: function click($event) {
	        $event.preventDefault();
	        return _vm.handleCloseBtnClick($event);
	      }
	    }
	  }, [_vm._v("x")]), _vm._v(" "), _c("div", { staticClass: "fm-dialog-body" }, [_vm._t("default")], 2)])])]);
	};
	var __vue_staticRenderFns__$1 = [];
	__vue_render__$1._withStripped = true;

	/* style */
	var __vue_inject_styles__$1 = function __vue_inject_styles__(inject) {
	  if (!inject) return;
	  inject("data-v-cfeefd60_0", { source: "\n.fm-dialog {\n  position: fixed;\n  top: 0;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  background: rgba(0, 0, 0, 0.5);\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  z-index: 2;\n}\n.fm-dialog-content {\n  position: relative;\n  background: white;\n  color: #000;\n  border-radius: .2em;\n}\n.fm-dialog-close-btn {\n  position: absolute;\n  top: -15px;\n  right: -15px;\n  color: #fff;\n  padding: 5px 10px;\n  border-radius: 50%;\n  background: #FF6F91;\n  font-size: 20px;\n  line-height: 1;\n  text-decoration: none;\n  cursor: pointer;\n  user-select: none;\n}\n.fm-dialog-body {\n  padding: 20px;\n}\n", map: { "version": 3, "sources": ["D:\\Workspaces\\fabirc-map-vue/D:\\Workspaces\\fabirc-map-vue\\src\\components\\fabric-map-vue\\FmDialog.vue"], "names": [], "mappings": ";AAqCA;EACA,gBAAA;EACA,OAAA;EACA,QAAA;EACA,SAAA;EACA,UAAA;EACA,+BAAA;EACA,cAAA;EACA,oBAAA;EACA,wBAAA;EACA,WAAA;CACA;AACA;EACA,mBAAA;EACA,kBAAA;EACA,YAAA;EACA,oBAAA;CACA;AACA;EACA,mBAAA;EACA,WAAA;EACA,aAAA;EACA,YAAA;EACA,kBAAA;EACA,mBAAA;EACA,oBAAA;EACA,gBAAA;EACA,eAAA;EACA,sBAAA;EACA,gBAAA;EACA,kBAAA;CACA;AACA;EACA,cAAA;CACA", "file": "FmDialog.vue", "sourcesContent": ["<template>\r\n  <div v-show=\"visible\">\r\n    <div class=\"fm-dialog\" >\r\n      <div class=\"fm-dialog-content\" :style=\"{'width': width, 'min-height': minHeight}\">\r\n        <div class=\"fm-dialog-close-btn\" @click.prevent=\"handleCloseBtnClick\">x</div>\r\n        <div class=\"fm-dialog-body\">\r\n          <slot></slot>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</template>\r\n<script>\r\nexport default {\r\n  props: {\r\n    width: {\r\n      type: String,\r\n      default: '50%'\r\n    },\r\n    minHeight: {\r\n      type: String,\r\n      default: '100px'\r\n    },\r\n    visible: {\r\n      type: Boolean,\r\n      default: false\r\n    }\r\n  },\r\n  methods: {\r\n    handleCloseBtnClick () {\r\n      this.$emit('update:visible', false)\r\n      this.$emit('close')\r\n    }\r\n  }\r\n}\r\n</script>\r\n<style>\r\n  .fm-dialog {\r\n    position: fixed;\r\n    top: 0;\r\n    left: 0;\r\n    right: 0;\r\n    bottom: 0;\r\n    background: rgba(0, 0, 0, 0.5);\r\n    display: flex;\r\n    align-items: center;\r\n    justify-content: center;\r\n    z-index: 2;\r\n  }\r\n  .fm-dialog-content {\r\n    position: relative;\r\n    background: white;\r\n    color: #000;\r\n    border-radius: .2em;\r\n  }\r\n  .fm-dialog-close-btn {\r\n    position: absolute;\r\n    top: -15px;\r\n    right: -15px;\r\n    color: #fff;\r\n    padding: 5px 10px;\r\n    border-radius: 50%;\r\n    background: #FF6F91;\r\n    font-size: 20px;\r\n    line-height: 1;\r\n    text-decoration: none;\r\n    cursor: pointer;\r\n    user-select: none;\r\n  }\r\n  .fm-dialog-body {\r\n    padding: 20px;\r\n  }\r\n</style>\r\n"] }, media: undefined });
	};
	/* scoped */
	var __vue_scope_id__$1 = undefined;
	/* module identifier */
	var __vue_module_identifier__$1 = undefined;
	/* functional template */
	var __vue_is_functional_template__$1 = false;
	/* component normalizer */
	function __vue_normalize__$1(template, style, script, scope, functional, moduleIdentifier, createInjector, createInjectorSSR) {
	  var component = (typeof script === 'function' ? script.options : script) || {};

	  // For security concerns, we use only base name in production mode.
	  component.__file = "D:\\Workspaces\\fabirc-map-vue\\src\\components\\fabric-map-vue\\FmDialog.vue";

	  if (!component.render) {
	    component.render = template.render;
	    component.staticRenderFns = template.staticRenderFns;
	    component._compiled = true;

	    if (functional) component.functional = true;
	  }

	  component._scopeId = scope;

	  {
	    var hook = void 0;
	    if (style) {
	      hook = function hook(context) {
	        style.call(this, createInjector(context));
	      };
	    }

	    if (hook !== undefined) {
	      if (component.functional) {
	        // register for functional component in vue file
	        var originalRender = component.render;
	        component.render = function renderWithStyleInjection(h, context) {
	          hook.call(context);
	          return originalRender(h, context);
	        };
	      } else {
	        // inject component registration as beforeCreate hook
	        var existing = component.beforeCreate;
	        component.beforeCreate = existing ? [].concat(existing, hook) : [hook];
	      }
	    }
	  }

	  return component;
	}
	/* style inject */
	function __vue_create_injector__$1() {
	  var head = document.head || document.getElementsByTagName('head')[0];
	  var styles = __vue_create_injector__$1.styles || (__vue_create_injector__$1.styles = {});
	  var isOldIE = typeof navigator !== 'undefined' && /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());

	  return function addStyle(id, css) {
	    if (document.querySelector('style[data-vue-ssr-id~="' + id + '"]')) return; // SSR styles are present.

	    var group = isOldIE ? css.media || 'default' : id;
	    var style = styles[group] || (styles[group] = { ids: [], parts: [], element: undefined });

	    if (!style.ids.includes(id)) {
	      var code = css.source;
	      var index = style.ids.length;

	      style.ids.push(id);

	      if (isOldIE) {
	        style.element = style.element || document.querySelector('style[data-group=' + group + ']');
	      }

	      if (!style.element) {
	        var el = style.element = document.createElement('style');
	        el.type = 'text/css';

	        if (css.media) el.setAttribute('media', css.media);
	        if (isOldIE) {
	          el.setAttribute('data-group', group);
	          el.setAttribute('data-next-index', '0');
	        }

	        head.appendChild(el);
	      }

	      if (isOldIE) {
	        index = parseInt(style.element.getAttribute('data-next-index'));
	        style.element.setAttribute('data-next-index', index + 1);
	      }

	      if (style.element.styleSheet) {
	        style.parts.push(code);
	        style.element.styleSheet.cssText = style.parts.filter(Boolean).join('\n');
	      } else {
	        var textNode = document.createTextNode(code);
	        var nodes = style.element.childNodes;
	        if (nodes[index]) style.element.removeChild(nodes[index]);
	        if (nodes.length) style.element.insertBefore(textNode, nodes[index]);else style.element.appendChild(textNode);
	      }
	    }
	  };
	}
	/* style inject SSR */

	var FmDialog = __vue_normalize__$1({ render: __vue_render__$1, staticRenderFns: __vue_staticRenderFns__$1 }, __vue_inject_styles__$1, __vue_script__$1, __vue_scope_id__$1, __vue_is_functional_template__$1, __vue_module_identifier__$1, __vue_create_injector__$1, undefined);

	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//

	var script$2 = {
	  props: {
	    data: {
	      type: Object,
	      default: function _default() {
	        return {};
	      }
	    }
	  },
	  data: function data() {
	    return {
	      form: {
	        text: '',
	        fontSize: '',
	        fill: '',
	        angle: ''
	      }
	    };
	  },
	  mounted: function mounted() {
	    this.form = _extends({}, this.form, this.data);
	  },

	  methods: {
	    handleSubmitBtnClick: function handleSubmitBtnClick() {
	      var _this = this;

	      if (!this.form.text) return;
	      this.$emit('submit', Object.keys(this.form).reduce(function (val, key) {
	        if (_this.form[key] || _this.form[key] === 0) val[key] = _this.form[key];
	        return val;
	      }, {}));
	    }
	  }
	};

	/* script */
	var __vue_script__$2 = script$2;

	/* template */
	var __vue_render__$2 = function __vue_render__() {
	  var _vm = this;
	  var _h = _vm.$createElement;
	  var _c = _vm._self._c || _h;
	  return _c("form", { staticClass: "fm-form" }, [_c("div", { staticClass: "fm-form-item" }, [_c("label", [_vm._v("文本内容:")]), _c("input", {
	    directives: [{
	      name: "model",
	      rawName: "v-model.trim",
	      value: _vm.form.text,
	      expression: "form.text",
	      modifiers: { trim: true }
	    }],
	    attrs: { placeholder: "例如：text" },
	    domProps: { value: _vm.form.text },
	    on: {
	      input: function input($event) {
	        if ($event.target.composing) {
	          return;
	        }
	        _vm.$set(_vm.form, "text", $event.target.value.trim());
	      },
	      blur: function blur($event) {
	        _vm.$forceUpdate();
	      }
	    }
	  })]), _vm._v(" "), _c("div", { staticClass: "fm-form-item" }, [_c("label", [_vm._v("字体大小:")]), _c("input", {
	    directives: [{
	      name: "model",
	      rawName: "v-model.number",
	      value: _vm.form.fontSize,
	      expression: "form.fontSize",
	      modifiers: { number: true }
	    }],
	    attrs: { placeholder: "例如：16" },
	    domProps: { value: _vm.form.fontSize },
	    on: {
	      input: function input($event) {
	        if ($event.target.composing) {
	          return;
	        }
	        _vm.$set(_vm.form, "fontSize", _vm._n($event.target.value));
	      },
	      blur: function blur($event) {
	        _vm.$forceUpdate();
	      }
	    }
	  })]), _vm._v(" "), _c("div", { staticClass: "fm-form-item" }, [_c("label", [_vm._v("       颜色:")]), _c("input", {
	    directives: [{
	      name: "model",
	      rawName: "v-model",
	      value: _vm.form.fill,
	      expression: "form.fill"
	    }],
	    attrs: { placeholder: "例如：red或者#FF0000" },
	    domProps: { value: _vm.form.fill },
	    on: {
	      input: function input($event) {
	        if ($event.target.composing) {
	          return;
	        }
	        _vm.$set(_vm.form, "fill", $event.target.value);
	      }
	    }
	  })]), _vm._v(" "), _c("div", { staticClass: "fm-form-item" }, [_c("label", [_vm._v("旋转角度:")]), _c("input", {
	    directives: [{
	      name: "model",
	      rawName: "v-model.number",
	      value: _vm.form.angle,
	      expression: "form.angle",
	      modifiers: { number: true }
	    }],
	    attrs: { placeholder: "例如：50" },
	    domProps: { value: _vm.form.angle },
	    on: {
	      input: function input($event) {
	        if ($event.target.composing) {
	          return;
	        }
	        _vm.$set(_vm.form, "angle", _vm._n($event.target.value));
	      },
	      blur: function blur($event) {
	        _vm.$forceUpdate();
	      }
	    }
	  })]), _vm._v(" "), _c("div", { staticClass: "fm-btn-wrapper" }, [_c("button", {
	    staticClass: "fm-btn",
	    on: {
	      click: function click($event) {
	        $event.preventDefault();
	        return _vm.handleSubmitBtnClick($event);
	      }
	    }
	  }, [_vm._v("确定")])])]);
	};
	var __vue_staticRenderFns__$2 = [];
	__vue_render__$2._withStripped = true;

	/* style */
	var __vue_inject_styles__$2 = function __vue_inject_styles__(inject) {
	  if (!inject) return;
	  inject("data-v-1a517e9a_0", { source: "\n.fm-form input {\n  border: 1px solid #bdb7b7;\n  border-radius: 5px;\n  min-height: 30px;\n  min-width: 200px;\n  padding: 0 10px;\n  font-size: 16px;\n  color: #000;\n}\n.fm-form .fm-form-item {\n  padding: 5px;\n}\n.fm-form-item label {\n  padding-right: 10px;\n}\n.fm-btn-wrapper .fm-btn {\n  padding: 5px;\n  border-radius: 5px;\n  border: none;\n  min-width: 80px;\n  line-height: 1.5;\n  background-color: #409eff;\n  border-color: #409eff;\n  color: white;\n}\n", map: { "version": 3, "sources": ["D:\\Workspaces\\fabirc-map-vue/D:\\Workspaces\\fabirc-map-vue\\src\\components\\fabric-map-vue\\FmTextForm.vue"], "names": [], "mappings": ";AAyDA;EACA,0BAAA;EACA,mBAAA;EACA,iBAAA;EACA,iBAAA;EACA,gBAAA;EACA,gBAAA;EACA,YAAA;CACA;AACA;EACA,aAAA;CACA;AACA;EACA,oBAAA;CACA;AACA;EACA,aAAA;EACA,mBAAA;EACA,aAAA;EACA,gBAAA;EACA,iBAAA;EACA,0BAAA;EACA,sBAAA;EACA,aAAA;CACA", "file": "FmTextForm.vue", "sourcesContent": ["<template>\r\n  <form class=\"fm-form\">\r\n    <div class=\"fm-form-item\">\r\n      <label>文本内容:</label><input v-model.trim=\"form.text\" placeholder=\"例如：text\"/>\r\n    </div>\r\n    <div class=\"fm-form-item\">\r\n      <label>字体大小:</label><input v-model.number=\"form.fontSize\" placeholder=\"例如：16\"/>\r\n    </div>\r\n    <div class=\"fm-form-item\">\r\n      <label>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;颜色:</label><input v-model=\"form.fill\" placeholder=\"例如：red或者#FF0000\"/>\r\n    </div>\r\n    <div class=\"fm-form-item\">\r\n      <label>旋转角度:</label><input v-model.number=\"form.angle\" placeholder=\"例如：50\"/>\r\n    </div>\r\n    <div class=\"fm-btn-wrapper\">\r\n      <button class=\"fm-btn\" @click.prevent=\"handleSubmitBtnClick\">确定</button>\r\n    </div>\r\n  </form>\r\n</template>\r\n<script>\r\nexport default {\r\n  props: {\r\n    data: {\r\n      type: Object,\r\n      default () {\r\n        return {}\r\n      }\r\n    }\r\n  },\r\n  data () {\r\n    return {\r\n      form: {\r\n        text: '',\r\n        fontSize: '',\r\n        fill: '',\r\n        angle: ''\r\n      }\r\n    }\r\n  },\r\n  mounted () {\r\n    this.form = {\r\n      ...this.form,\r\n      ...this.data\r\n    }\r\n  },\r\n  methods: {\r\n    handleSubmitBtnClick () {\r\n      if (!this.form.text) return\r\n      this.$emit('submit', Object.keys(this.form).reduce((val, key) => {\r\n        if (this.form[key] || this.form[key] === 0) val[key] = this.form[key]\r\n        return val\r\n      }, {}))\r\n    }\r\n  }\r\n}\r\n</script>\r\n<style>\r\n  .fm-form input {\r\n    border: 1px solid #bdb7b7;\r\n    border-radius: 5px;\r\n    min-height: 30px;\r\n    min-width: 200px;\r\n    padding: 0 10px;\r\n    font-size: 16px;\r\n    color: #000;\r\n  }\r\n  .fm-form .fm-form-item {\r\n    padding: 5px;\r\n  }\r\n  .fm-form-item label {\r\n    padding-right: 10px;\r\n  }\r\n  .fm-btn-wrapper .fm-btn {\r\n    padding: 5px;\r\n    border-radius: 5px;\r\n    border: none;\r\n    min-width: 80px;\r\n    line-height: 1.5;\r\n    background-color: #409eff;\r\n    border-color: #409eff;\r\n    color: white;\r\n  }\r\n</style>\r\n"] }, media: undefined });
	};
	/* scoped */
	var __vue_scope_id__$2 = undefined;
	/* module identifier */
	var __vue_module_identifier__$2 = undefined;
	/* functional template */
	var __vue_is_functional_template__$2 = false;
	/* component normalizer */
	function __vue_normalize__$2(template, style, script, scope, functional, moduleIdentifier, createInjector, createInjectorSSR) {
	  var component = (typeof script === 'function' ? script.options : script) || {};

	  // For security concerns, we use only base name in production mode.
	  component.__file = "D:\\Workspaces\\fabirc-map-vue\\src\\components\\fabric-map-vue\\FmTextForm.vue";

	  if (!component.render) {
	    component.render = template.render;
	    component.staticRenderFns = template.staticRenderFns;
	    component._compiled = true;

	    if (functional) component.functional = true;
	  }

	  component._scopeId = scope;

	  {
	    var hook = void 0;
	    if (style) {
	      hook = function hook(context) {
	        style.call(this, createInjector(context));
	      };
	    }

	    if (hook !== undefined) {
	      if (component.functional) {
	        // register for functional component in vue file
	        var originalRender = component.render;
	        component.render = function renderWithStyleInjection(h, context) {
	          hook.call(context);
	          return originalRender(h, context);
	        };
	      } else {
	        // inject component registration as beforeCreate hook
	        var existing = component.beforeCreate;
	        component.beforeCreate = existing ? [].concat(existing, hook) : [hook];
	      }
	    }
	  }

	  return component;
	}
	/* style inject */
	function __vue_create_injector__$2() {
	  var head = document.head || document.getElementsByTagName('head')[0];
	  var styles = __vue_create_injector__$2.styles || (__vue_create_injector__$2.styles = {});
	  var isOldIE = typeof navigator !== 'undefined' && /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());

	  return function addStyle(id, css) {
	    if (document.querySelector('style[data-vue-ssr-id~="' + id + '"]')) return; // SSR styles are present.

	    var group = isOldIE ? css.media || 'default' : id;
	    var style = styles[group] || (styles[group] = { ids: [], parts: [], element: undefined });

	    if (!style.ids.includes(id)) {
	      var code = css.source;
	      var index = style.ids.length;

	      style.ids.push(id);

	      if (isOldIE) {
	        style.element = style.element || document.querySelector('style[data-group=' + group + ']');
	      }

	      if (!style.element) {
	        var el = style.element = document.createElement('style');
	        el.type = 'text/css';

	        if (css.media) el.setAttribute('media', css.media);
	        if (isOldIE) {
	          el.setAttribute('data-group', group);
	          el.setAttribute('data-next-index', '0');
	        }

	        head.appendChild(el);
	      }

	      if (isOldIE) {
	        index = parseInt(style.element.getAttribute('data-next-index'));
	        style.element.setAttribute('data-next-index', index + 1);
	      }

	      if (style.element.styleSheet) {
	        style.parts.push(code);
	        style.element.styleSheet.cssText = style.parts.filter(Boolean).join('\n');
	      } else {
	        var textNode = document.createTextNode(code);
	        var nodes = style.element.childNodes;
	        if (nodes[index]) style.element.removeChild(nodes[index]);
	        if (nodes.length) style.element.insertBefore(textNode, nodes[index]);else style.element.appendChild(textNode);
	      }
	    }
	  };
	}
	/* style inject SSR */

	var FmTextForm = __vue_normalize__$2({ render: __vue_render__$2, staticRenderFns: __vue_staticRenderFns__$2 }, __vue_inject_styles__$2, __vue_script__$2, __vue_scope_id__$2, __vue_is_functional_template__$2, __vue_module_identifier__$2, __vue_create_injector__$2, undefined);

	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//

	var script$3 = {
	  props: {
	    data: {
	      type: Object,
	      default: function _default() {
	        return {};
	      }
	    }
	  },
	  data: function data() {
	    return {
	      form: {
	        url: '', // http://vve.qiniu.qjzd.net/Fn4PgPav04qGpPzpIDw_1qyK9F5Y
	        angle: ''
	      }
	    };
	  },
	  mounted: function mounted() {
	    this.form = _extends({}, this.form, this.data);
	  },

	  methods: {
	    handleSubmitBtnClick: function handleSubmitBtnClick() {
	      var _this = this;

	      if (!this.form.url) return;
	      this.$emit('submit', Object.keys(this.form).reduce(function (val, key) {
	        if (_this.form[key] || _this.form[key] === 0) val[key] = _this.form[key];
	        return val;
	      }, {}));
	    }
	  }
	};

	/* script */
	var __vue_script__$3 = script$3;

	/* template */
	var __vue_render__$3 = function __vue_render__() {
	  var _vm = this;
	  var _h = _vm.$createElement;
	  var _c = _vm._self._c || _h;
	  return _c("form", { staticClass: "fm-form" }, [_c("div", { staticClass: "fm-form-item" }, [_c("label", [_vm._v("图片地址:")]), _c("input", {
	    directives: [{
	      name: "model",
	      rawName: "v-model.trim",
	      value: _vm.form.url,
	      expression: "form.url",
	      modifiers: { trim: true }
	    }],
	    attrs: {
	      placeholder: "例如：http://vve.qiniu.qjzd.net/Fn4PgPav04qGpPzpIDw_1qyK9F5Y"
	    },
	    domProps: { value: _vm.form.url },
	    on: {
	      input: function input($event) {
	        if ($event.target.composing) {
	          return;
	        }
	        _vm.$set(_vm.form, "url", $event.target.value.trim());
	      },
	      blur: function blur($event) {
	        _vm.$forceUpdate();
	      }
	    }
	  })]), _vm._v(" "), _c("div", { staticClass: "fm-form-item" }, [_c("label", [_vm._v("旋转角度:")]), _c("input", {
	    directives: [{
	      name: "model",
	      rawName: "v-model.number",
	      value: _vm.form.angle,
	      expression: "form.angle",
	      modifiers: { number: true }
	    }],
	    attrs: { placeholder: "例如：50" },
	    domProps: { value: _vm.form.angle },
	    on: {
	      input: function input($event) {
	        if ($event.target.composing) {
	          return;
	        }
	        _vm.$set(_vm.form, "angle", _vm._n($event.target.value));
	      },
	      blur: function blur($event) {
	        _vm.$forceUpdate();
	      }
	    }
	  })]), _vm._v(" "), _c("div", { staticClass: "fm-btn-wrapper" }, [_c("button", {
	    staticClass: "fm-btn",
	    on: {
	      click: function click($event) {
	        $event.preventDefault();
	        return _vm.handleSubmitBtnClick($event);
	      }
	    }
	  }, [_vm._v("确定")])])]);
	};
	var __vue_staticRenderFns__$3 = [];
	__vue_render__$3._withStripped = true;

	/* style */
	var __vue_inject_styles__$3 = function __vue_inject_styles__(inject) {
	  if (!inject) return;
	  inject("data-v-301f766c_0", { source: "\n.fm-form input {\n  border: 1px solid #bdb7b7;\n  border-radius: 5px;\n  min-height: 30px;\n  min-width: 200px;\n  padding: 0 10px;\n  font-size: 16px;\n  color: #000;\n}\n.fm-form .fm-form-item {\n  padding: 5px;\n}\n.fm-form-item label {\n  padding-right: 10px;\n}\n.fm-btn-wrapper .fm-btn {\n  padding: 5px;\n  border-radius: 5px;\n  border: none;\n  min-width: 80px;\n  line-height: 1.5;\n  background-color: #409eff;\n  border-color: #409eff;\n  color: white;\n}\n", map: { "version": 3, "sources": ["D:\\Workspaces\\fabirc-map-vue/D:\\Workspaces\\fabirc-map-vue\\src\\components\\fabric-map-vue\\FmImgForm.vue"], "names": [], "mappings": ";AAiDA;EACA,0BAAA;EACA,mBAAA;EACA,iBAAA;EACA,iBAAA;EACA,gBAAA;EACA,gBAAA;EACA,YAAA;CACA;AACA;EACA,aAAA;CACA;AACA;EACA,oBAAA;CACA;AACA;EACA,aAAA;EACA,mBAAA;EACA,aAAA;EACA,gBAAA;EACA,iBAAA;EACA,0BAAA;EACA,sBAAA;EACA,aAAA;CACA", "file": "FmImgForm.vue", "sourcesContent": ["<template>\r\n  <form class=\"fm-form\">\r\n    <div class=\"fm-form-item\">\r\n      <label>图片地址:</label><input v-model.trim=\"form.url\" placeholder=\"例如：http://vve.qiniu.qjzd.net/Fn4PgPav04qGpPzpIDw_1qyK9F5Y\"/>\r\n    </div>\r\n    <div class=\"fm-form-item\">\r\n      <label>旋转角度:</label><input v-model.number=\"form.angle\" placeholder=\"例如：50\"/>\r\n    </div>\r\n    <div class=\"fm-btn-wrapper\">\r\n      <button class=\"fm-btn\" @click.prevent=\"handleSubmitBtnClick\">确定</button>\r\n    </div>\r\n  </form>\r\n</template>\r\n<script>\r\nexport default {\r\n  props: {\r\n    data: {\r\n      type: Object,\r\n      default () {\r\n        return {}\r\n      }\r\n    }\r\n  },\r\n  data () {\r\n    return {\r\n      form: {\r\n        url: '',// http://vve.qiniu.qjzd.net/Fn4PgPav04qGpPzpIDw_1qyK9F5Y\r\n        angle: ''\r\n      }\r\n    }\r\n  },\r\n  mounted () {\r\n    this.form = {\r\n      ...this.form,\r\n      ...this.data\r\n    }\r\n  },\r\n  methods: {\r\n    handleSubmitBtnClick () {\r\n      if (!this.form.url) return\r\n      this.$emit('submit', Object.keys(this.form).reduce((val, key) => {\r\n        if (this.form[key] || this.form[key] === 0) val[key] = this.form[key]\r\n        return val\r\n      }, {}))\r\n    }\r\n  }\r\n}\r\n</script>\r\n<style>\r\n  .fm-form input {\r\n    border: 1px solid #bdb7b7;\r\n    border-radius: 5px;\r\n    min-height: 30px;\r\n    min-width: 200px;\r\n    padding: 0 10px;\r\n    font-size: 16px;\r\n    color: #000;\r\n  }\r\n  .fm-form .fm-form-item {\r\n    padding: 5px;\r\n  }\r\n  .fm-form-item label {\r\n    padding-right: 10px;\r\n  }\r\n  .fm-btn-wrapper .fm-btn {\r\n    padding: 5px;\r\n    border-radius: 5px;\r\n    border: none;\r\n    min-width: 80px;\r\n    line-height: 1.5;\r\n    background-color: #409eff;\r\n    border-color: #409eff;\r\n    color: white;\r\n  }\r\n</style>\r\n"] }, media: undefined });
	};
	/* scoped */
	var __vue_scope_id__$3 = undefined;
	/* module identifier */
	var __vue_module_identifier__$3 = undefined;
	/* functional template */
	var __vue_is_functional_template__$3 = false;
	/* component normalizer */
	function __vue_normalize__$3(template, style, script, scope, functional, moduleIdentifier, createInjector, createInjectorSSR) {
	  var component = (typeof script === 'function' ? script.options : script) || {};

	  // For security concerns, we use only base name in production mode.
	  component.__file = "D:\\Workspaces\\fabirc-map-vue\\src\\components\\fabric-map-vue\\FmImgForm.vue";

	  if (!component.render) {
	    component.render = template.render;
	    component.staticRenderFns = template.staticRenderFns;
	    component._compiled = true;

	    if (functional) component.functional = true;
	  }

	  component._scopeId = scope;

	  {
	    var hook = void 0;
	    if (style) {
	      hook = function hook(context) {
	        style.call(this, createInjector(context));
	      };
	    }

	    if (hook !== undefined) {
	      if (component.functional) {
	        // register for functional component in vue file
	        var originalRender = component.render;
	        component.render = function renderWithStyleInjection(h, context) {
	          hook.call(context);
	          return originalRender(h, context);
	        };
	      } else {
	        // inject component registration as beforeCreate hook
	        var existing = component.beforeCreate;
	        component.beforeCreate = existing ? [].concat(existing, hook) : [hook];
	      }
	    }
	  }

	  return component;
	}
	/* style inject */
	function __vue_create_injector__$3() {
	  var head = document.head || document.getElementsByTagName('head')[0];
	  var styles = __vue_create_injector__$3.styles || (__vue_create_injector__$3.styles = {});
	  var isOldIE = typeof navigator !== 'undefined' && /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());

	  return function addStyle(id, css) {
	    if (document.querySelector('style[data-vue-ssr-id~="' + id + '"]')) return; // SSR styles are present.

	    var group = isOldIE ? css.media || 'default' : id;
	    var style = styles[group] || (styles[group] = { ids: [], parts: [], element: undefined });

	    if (!style.ids.includes(id)) {
	      var code = css.source;
	      var index = style.ids.length;

	      style.ids.push(id);

	      if (isOldIE) {
	        style.element = style.element || document.querySelector('style[data-group=' + group + ']');
	      }

	      if (!style.element) {
	        var el = style.element = document.createElement('style');
	        el.type = 'text/css';

	        if (css.media) el.setAttribute('media', css.media);
	        if (isOldIE) {
	          el.setAttribute('data-group', group);
	          el.setAttribute('data-next-index', '0');
	        }

	        head.appendChild(el);
	      }

	      if (isOldIE) {
	        index = parseInt(style.element.getAttribute('data-next-index'));
	        style.element.setAttribute('data-next-index', index + 1);
	      }

	      if (style.element.styleSheet) {
	        style.parts.push(code);
	        style.element.styleSheet.cssText = style.parts.filter(Boolean).join('\n');
	      } else {
	        var textNode = document.createTextNode(code);
	        var nodes = style.element.childNodes;
	        if (nodes[index]) style.element.removeChild(nodes[index]);
	        if (nodes.length) style.element.insertBefore(textNode, nodes[index]);else style.element.appendChild(textNode);
	      }
	    }
	  };
	}
	/* style inject SSR */

	var FmImgForm = __vue_normalize__$3({ render: __vue_render__$3, staticRenderFns: __vue_staticRenderFns__$3 }, __vue_inject_styles__$3, __vue_script__$3, __vue_scope_id__$3, __vue_is_functional_template__$3, __vue_module_identifier__$3, __vue_create_injector__$3, undefined);

	//

	var TYPELIST = [{ type: POINT_TYPE_ENUM.TEXT, text: '文本', component: FmTextForm }, { type: POINT_TYPE_ENUM.IMG, text: '图片', component: FmImgForm }];

	var script$4 = {
	  props: {
	    data: {
	      type: Object,
	      required: false
	    }
	  },
	  components: {
	    FmTextForm: FmTextForm,
	    FmDialog: FmDialog
	  },
	  data: function data() {
	    return {
	      TYPELIST: TYPELIST,
	      POINT_TYPE_ENUM: POINT_TYPE_ENUM,
	      visible: true,
	      formVisible: false,
	      fmType: {}
	    };
	  },
	  mounted: function mounted() {
	    var _this = this;

	    if (this.data) {
	      this.fmType = TYPELIST.find(function (item) {
	        return item.type === _this.data.type;
	      }) || {};
	      if (this.fmType.type) {
	        this.formVisible = true;
	        this.visible = false;
	      }
	    }
	  },

	  methods: {
	    handleItemClick: function handleItemClick(item) {
	      this.fmType = item;
	      this.visible = false;
	      this.formVisible = true;
	    },
	    handleFormCloseBtnClick: function handleFormCloseBtnClick() {
	      if (this.data) {
	        this.$emit('close');
	      } else {
	        this.visible = true;
	      }
	    },
	    handleFormSubmit: function handleFormSubmit(data) {
	      this.$emit('submit', _extends({
	        type: this.fmType.type
	      }, data));
	    },
	    handleCloseBtnClick: function handleCloseBtnClick() {
	      this.$emit('close');
	    }
	  }
	};

	/* script */
	var __vue_script__$4 = script$4;

	/* template */
	var __vue_render__$4 = function __vue_render__() {
	  var _vm = this;
	  var _h = _vm.$createElement;
	  var _c = _vm._self._c || _h;
	  return _c("div", [_c("fm-dialog", {
	    attrs: { visible: _vm.visible },
	    on: {
	      "update:visible": function updateVisible($event) {
	        _vm.visible = $event;
	      },
	      close: _vm.handleCloseBtnClick
	    }
	  }, [_c("p", [_vm._v("选择类型")]), _vm._v(" "), _c("div", { staticClass: "fm-type-select-wrapper" }, _vm._l(_vm.TYPELIST, function (item) {
	    return _c("div", {
	      key: item.type,
	      staticClass: "fm-type",
	      on: {
	        click: function click($event) {
	          _vm.handleItemClick(item);
	        }
	      }
	    }, [_c("span", { domProps: { textContent: _vm._s(item.text) } })]);
	  }))]), _vm._v(" "), _c("fm-dialog", {
	    attrs: { visible: _vm.formVisible },
	    on: {
	      "update:visible": function updateVisible($event) {
	        _vm.formVisible = $event;
	      },
	      close: _vm.handleFormCloseBtnClick
	    }
	  }, [_c(_vm.fmType.component, {
	    tag: "component",
	    attrs: { data: _vm.data },
	    on: { submit: _vm.handleFormSubmit }
	  })], 1)], 1);
	};
	var __vue_staticRenderFns__$4 = [];
	__vue_render__$4._withStripped = true;

	/* style */
	var __vue_inject_styles__$4 = function __vue_inject_styles__(inject) {
	  if (!inject) return;
	  inject("data-v-fb4a7a20_0", { source: "\n.fm-type-select-wrapper {\n  display: flex;\n  box-sizing: border-box;\n}\n.fm-type {\n  flex: 1;\n  margin: 10px;\n  text-align: center;\n  background: #ff6f91;\n  padding: 20px 0;\n  border-radius: 5px;\n  cursor: pointer;\n}\n.fm-type:active {\n}\n.fm-type input {\n  display: none;\n}\n", map: { "version": 3, "sources": ["D:\\Workspaces\\fabirc-map-vue/D:\\Workspaces\\fabirc-map-vue\\src\\components\\fabric-map-vue\\FmForm.vue"], "names": [], "mappings": ";AAiFA;EACA,cAAA;EACA,uBAAA;CACA;AACA;EACA,QAAA;EACA,aAAA;EACA,mBAAA;EACA,oBAAA;EACA,gBAAA;EACA,mBAAA;EACA,gBAAA;CACA;AACA;CACA;AACA;EACA,cAAA;CACA", "file": "FmForm.vue", "sourcesContent": ["<template>\r\n  <div>\r\n    <fm-dialog :visible.sync=\"visible\" @close=\"handleCloseBtnClick\">\r\n      <p>选择类型</p>\r\n      <div class=\"fm-type-select-wrapper\">\r\n        <div class=\"fm-type\" v-for=\"item of TYPELIST\" :key=\"item.type\"  @click=\"handleItemClick(item)\">\r\n          <span v-text=\"item.text\"></span>\r\n        </div>\r\n      </div>\r\n    </fm-dialog>\r\n    <fm-dialog :visible.sync=\"formVisible\" @close=\"handleFormCloseBtnClick\">\r\n      <component :is=\"fmType.component\" @submit=\"handleFormSubmit\" :data=\"data\"></component>\r\n    </fm-dialog>\r\n  </div>\r\n</template>\r\n<script>\r\nimport { POINT_TYPE_ENUM } from './constants'\r\nimport FmDialog from './FmDialog'\r\nimport FmTextForm from './FmTextForm'\r\nimport FmImgForm from './FmImgForm'\r\n\r\nconst TYPELIST = [\r\n  { type: POINT_TYPE_ENUM.TEXT, text: '文本', component: FmTextForm },\r\n  { type: POINT_TYPE_ENUM.IMG,  text: '图片', component: FmImgForm }\r\n]\r\n\r\nexport default {\r\n  props: {\r\n    data: {\r\n      type: Object,\r\n      required: false\r\n    },\r\n  },\r\n  components: {\r\n    FmTextForm,\r\n    FmDialog\r\n  },\r\n  data () {\r\n    return {\r\n      TYPELIST,\r\n      POINT_TYPE_ENUM,\r\n      visible: true,\r\n      formVisible: false,\r\n      fmType: {},\r\n    }\r\n  },\r\n  mounted () {\r\n    if (this.data) {\r\n      this.fmType = TYPELIST.find(item => item.type === this.data.type) || {}\r\n      if (this.fmType.type) {\r\n        this.formVisible = true\r\n        this.visible = false\r\n      }\r\n    }\r\n  },\r\n  methods: {\r\n    handleItemClick (item) {\r\n      this.fmType = item\r\n      this.visible = false\r\n      this.formVisible = true\r\n    },\r\n    handleFormCloseBtnClick () {\r\n      if (this.data) { \r\n        this.$emit('close')\r\n      } else {\r\n        this.visible = true\r\n      }\r\n    },\r\n    handleFormSubmit (data) {\r\n      this.$emit('submit', {\r\n        type: this.fmType.type,\r\n        ...data,\r\n      })\r\n    },\r\n    handleCloseBtnClick () {\r\n      this.$emit('close')\r\n    }\r\n  }\r\n}\r\n</script>\r\n<style>\r\n  .fm-type-select-wrapper {\r\n    display: flex;\r\n    box-sizing: border-box;\r\n  }\r\n  .fm-type {\r\n    flex: 1;\r\n    margin: 10px;\r\n    text-align: center;\r\n    background: #ff6f91;\r\n    padding: 20px 0;\r\n    border-radius: 5px;\r\n    cursor: pointer;\r\n  }\r\n  .fm-type:active {\r\n  }\r\n  .fm-type input {\r\n    display: none;\r\n  }\r\n</style>\r\n"] }, media: undefined });
	};
	/* scoped */
	var __vue_scope_id__$4 = undefined;
	/* module identifier */
	var __vue_module_identifier__$4 = undefined;
	/* functional template */
	var __vue_is_functional_template__$4 = false;
	/* component normalizer */
	function __vue_normalize__$4(template, style, script, scope, functional, moduleIdentifier, createInjector, createInjectorSSR) {
	  var component = (typeof script === 'function' ? script.options : script) || {};

	  // For security concerns, we use only base name in production mode.
	  component.__file = "D:\\Workspaces\\fabirc-map-vue\\src\\components\\fabric-map-vue\\FmForm.vue";

	  if (!component.render) {
	    component.render = template.render;
	    component.staticRenderFns = template.staticRenderFns;
	    component._compiled = true;

	    if (functional) component.functional = true;
	  }

	  component._scopeId = scope;

	  {
	    var hook = void 0;
	    if (style) {
	      hook = function hook(context) {
	        style.call(this, createInjector(context));
	      };
	    }

	    if (hook !== undefined) {
	      if (component.functional) {
	        // register for functional component in vue file
	        var originalRender = component.render;
	        component.render = function renderWithStyleInjection(h, context) {
	          hook.call(context);
	          return originalRender(h, context);
	        };
	      } else {
	        // inject component registration as beforeCreate hook
	        var existing = component.beforeCreate;
	        component.beforeCreate = existing ? [].concat(existing, hook) : [hook];
	      }
	    }
	  }

	  return component;
	}
	/* style inject */
	function __vue_create_injector__$4() {
	  var head = document.head || document.getElementsByTagName('head')[0];
	  var styles = __vue_create_injector__$4.styles || (__vue_create_injector__$4.styles = {});
	  var isOldIE = typeof navigator !== 'undefined' && /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());

	  return function addStyle(id, css) {
	    if (document.querySelector('style[data-vue-ssr-id~="' + id + '"]')) return; // SSR styles are present.

	    var group = isOldIE ? css.media || 'default' : id;
	    var style = styles[group] || (styles[group] = { ids: [], parts: [], element: undefined });

	    if (!style.ids.includes(id)) {
	      var code = css.source;
	      var index = style.ids.length;

	      style.ids.push(id);

	      if (isOldIE) {
	        style.element = style.element || document.querySelector('style[data-group=' + group + ']');
	      }

	      if (!style.element) {
	        var el = style.element = document.createElement('style');
	        el.type = 'text/css';

	        if (css.media) el.setAttribute('media', css.media);
	        if (isOldIE) {
	          el.setAttribute('data-group', group);
	          el.setAttribute('data-next-index', '0');
	        }

	        head.appendChild(el);
	      }

	      if (isOldIE) {
	        index = parseInt(style.element.getAttribute('data-next-index'));
	        style.element.setAttribute('data-next-index', index + 1);
	      }

	      if (style.element.styleSheet) {
	        style.parts.push(code);
	        style.element.styleSheet.cssText = style.parts.filter(Boolean).join('\n');
	      } else {
	        var textNode = document.createTextNode(code);
	        var nodes = style.element.childNodes;
	        if (nodes[index]) style.element.removeChild(nodes[index]);
	        if (nodes.length) style.element.insertBefore(textNode, nodes[index]);else style.element.appendChild(textNode);
	      }
	    }
	  };
	}
	/* style inject SSR */

	var FmForm = __vue_normalize__$4({ render: __vue_render__$4, staticRenderFns: __vue_staticRenderFns__$4 }, __vue_inject_styles__$4, __vue_script__$4, __vue_scope_id__$4, __vue_is_functional_template__$4, __vue_module_identifier__$4, __vue_create_injector__$4, undefined);

	var DEFAULT_OPTIONS$1 = {};

	var FabricImgText = function (_fabric$Group) {
	  inherits(FabricImgText, _fabric$Group);

	  function FabricImgText(img, text) {
	    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
	    classCallCheck(this, FabricImgText);

	    var objects = [];
	    if (img) {
	      objects.push(img);
	    }
	    if (text) {
	      objects.push(text);
	    }
	    return possibleConstructorReturn(this, (FabricImgText.__proto__ || Object.getPrototypeOf(FabricImgText)).call(this, objects, _extends({}, DEFAULT_OPTIONS$1, options)));
	  }

	  return FabricImgText;
	}(fabric.Group);

	//

	// 过滤key
	function filterObjByKeys() {
	  var arrKeys = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
	  var obj = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

	  return arrKeys.reduce(function (val, key) {
	    if (obj[key] !== undefined) val[key] = obj[key];
	    return val;
	  }, {});
	}

	var script$5 = {
	  mixins: [fabricHeatmapMixin, fabricZoom, fabricAreaDistinguish, fabricPointLine],
	  components: {
	    DirBtn: DirBtn,
	    FmForm: FmForm
	  },
	  props: {
	    svgMapUrl: {
	      type: String,
	      default: 'https://qiniu.qjzd.net/cf.svg'
	    },
	    pointList: {
	      type: Array,
	      default: function _default() {
	        return [];
	      }
	    },
	    changeCb: {
	      type: Function,
	      default: function _default() {
	        return function () {};
	      }
	    },
	    deleteCb: {
	      type: Function,
	      default: function _default() {
	        return function () {};
	      }
	    },
	    movingMinion: {
	      type: Boolean,
	      default: false
	    },
	    scalingMinion: {
	      type: Boolean,
	      default: false
	    },
	    backgroundColor: {
	      type: String,
	      default: '#17171A'
	    },
	    showOp: {
	      type: Boolean,
	      default: false
	    }
	  },
	  data: function data() {
	    return {
	      addTipInfoShow: false,
	      activePoint: undefined,
	      selectedPoint: undefined,
	      formShow: false,
	      readyPointInfo: undefined,
	      editPointInfo: undefined
	    };
	  },

	  computed: {
	    lockBtn: function lockBtn() {
	      return !this.activePoint;
	    },
	    showLockBtn: function showLockBtn() {
	      var point = this.selectedPoint || this.activePoint;
	      return point;
	    },
	    showOpBtnWrapper: function showOpBtnWrapper() {
	      var point = this.selectedPoint || this.activePoint;
	      return !!point && point.mPointInfo && point.mPointInfo.type !== POINT_TYPE_ENUM.AREA;
	    },
	    showDeleteBtn: function showDeleteBtn() {
	      var point = this.activePoint || this.selectedPoint;
	      return point;
	    },
	    showEditBtn: function showEditBtn() {
	      var point = this.selectedPoint;
	      return point;
	    },
	    showAddPointBtn: function showAddPointBtn() {
	      return !(this.selectedPoint || this.activePoint) && !this.addTipInfoShow && !this.formShow;
	    },
	    showDirBtn: function showDirBtn() {
	      return !!this.activePoint;
	    },
	    pointInfo: function pointInfo() {
	      return this.selectedPoint && this.selectedPoint.mPointInfo || {};
	    },
	    mPointList: function mPointList() {
	      return this.pointList;
	    }
	  },
	  watch: {
	    svgMapUrl: function svgMapUrl(val) {
	      this.renderSvgMap(val);
	    },
	    pointList: function pointList() {
	      this.renderPoints();
	      this.canvas && this.canvas.requestRenderAll();
	    },
	    backgroundColor: function backgroundColor(val) {
	      this.canvas && (this.canvas.backgroundColor = val);
	      this.canvas && this.canvas.requestRenderAll();
	    }
	  },
	  mounted: function () {
	    var _ref = asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
	      return regeneratorRuntime.wrap(function _callee$(_context) {
	        while (1) {
	          switch (_context.prev = _context.next) {
	            case 0:
	              _context.next = 2;
	              return this.draw();

	            case 2:
	              this.initPointLine();
	              this.initZoom();
	              this.initHeatMap();
	              this.initAreaDistinguish();

	            case 6:
	            case 'end':
	              return _context.stop();
	          }
	        }
	      }, _callee, this);
	    }));

	    function mounted() {
	      return _ref.apply(this, arguments);
	    }

	    return mounted;
	  }(),
	  beforeDestroy: function beforeDestroy() {
	    this.canvas && this.canvas.destroy();
	  },

	  methods: {
	    handleFormSubmit: function () {
	      var _ref2 = asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(val) {
	        return regeneratorRuntime.wrap(function _callee2$(_context2) {
	          while (1) {
	            switch (_context2.prev = _context2.next) {
	              case 0:
	                this.formShow = false;

	                if (val.id) {
	                  _context2.next = 6;
	                  break;
	                }

	                this.readyPointInfo = val;
	                this.addTipInfoShow = true;
	                _context2.next = 10;
	                break;

	              case 6:
	                this.editPointInfo = undefined;
	                _context2.next = 9;
	                return this.callFun('changeCb', val);

	              case 9:
	                this.selectedPoint = null;

	              case 10:
	              case 'end':
	                return _context2.stop();
	            }
	          }
	        }, _callee2, this);
	      }));

	      function handleFormSubmit(_x3) {
	        return _ref2.apply(this, arguments);
	      }

	      return handleFormSubmit;
	    }(),
	    callFun: function () {
	      var _ref3 = asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(name) {
	        for (var _len = arguments.length, arg = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
	          arg[_key - 1] = arguments[_key];
	        }

	        return regeneratorRuntime.wrap(function _callee3$(_context3) {
	          while (1) {
	            switch (_context3.prev = _context3.next) {
	              case 0:
	                this.$emit.apply(this, [name.replace('Cb', '')].concat(toConsumableArray(arg)));

	                if (!(this[name] && this[name].then)) {
	                  _context3.next = 6;
	                  break;
	                }

	                _context3.next = 4;
	                return this[name].apply(this, toConsumableArray(arg));

	              case 4:
	                _context3.next = 7;
	                break;

	              case 6:
	                this[name] && this[name].apply(this, toConsumableArray(arg));

	              case 7:
	              case 'end':
	                return _context3.stop();
	            }
	          }
	        }, _callee3, this);
	      }));

	      function callFun(_x4) {
	        return _ref3.apply(this, arguments);
	      }

	      return callFun;
	    }(),

	    // 保存点坐标信息
	    savePointInfo: function () {
	      var _ref4 = asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
	        var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	        return regeneratorRuntime.wrap(function _callee4$(_context4) {
	          while (1) {
	            switch (_context4.prev = _context4.next) {
	              case 0:
	                _context4.next = 2;
	                return this.callFun('changeCb', data);

	              case 2:
	                return _context4.abrupt('return', data);

	              case 3:
	              case 'end':
	                return _context4.stop();
	            }
	          }
	        }, _callee4, this);
	      }));

	      function savePointInfo() {
	        return _ref4.apply(this, arguments);
	      }

	      return savePointInfo;
	    }(),
	    draw: function () {
	      var _ref5 = asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
	        var canvas;
	        return regeneratorRuntime.wrap(function _callee5$(_context5) {
	          while (1) {
	            switch (_context5.prev = _context5.next) {
	              case 0:
	                canvas = new FabricResizableCavas(this.$el.querySelector("#map-canvas"), { parentEl: this.$el.querySelector('.fm-map-wrapper') });

	                canvas.backgroundColor = this.backgroundColor;
	                canvas.selection = false;
	                this.canvas = canvas;

	                _context5.next = 6;
	                return this.renderSvgMap(this.svgMapUrl);

	              case 6:

	                canvas.on('mouse:down', this.handleCanvasMouseDown);
	                canvas.on('object:scaling', this.handleCanvasScaling);
	                canvas.on('object:moving', this.handleCanvasMoving);
	                canvas.on('mouse:up', this.handleCanvasMouseUp);

	              case 10:
	              case 'end':
	                return _context5.stop();
	            }
	          }
	        }, _callee5, this);
	      }));

	      function draw() {
	        return _ref5.apply(this, arguments);
	      }

	      return draw;
	    }(),

	    // 清除点信息
	    clearPoints: function clearPoints() {
	      if (!this.svgMap) return;
	      var _iteratorNormalCompletion = true;
	      var _didIteratorError = false;
	      var _iteratorError = undefined;

	      try {
	        for (var _iterator = this.svgMap.getObjects()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
	          var item = _step.value;

	          if (item.mType && item.mType === OBJ_POINT) {
	            this.svgMap.remove(item);
	          }
	        }
	      } catch (err) {
	        _didIteratorError = true;
	        _iteratorError = err;
	      } finally {
	        try {
	          if (!_iteratorNormalCompletion && _iterator.return) {
	            _iterator.return();
	          }
	        } finally {
	          if (_didIteratorError) {
	            throw _iteratorError;
	          }
	        }
	      }
	    },

	    // 创建point image对象
	    makePointImageObj: function () {
	      var _ref6 = asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
	        var _this = this;

	        var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

	        var _data$mPointInfo, mPointInfo, options, point, startPoints, clonedStartPoints, image, text;

	        return regeneratorRuntime.wrap(function _callee6$(_context6) {
	          while (1) {
	            switch (_context6.prev = _context6.next) {
	              case 0:
	                _data$mPointInfo = data.mPointInfo, mPointInfo = _data$mPointInfo === undefined ? {} : _data$mPointInfo, options = objectWithoutProperties(data, ['mPointInfo']);
	                point = void 0;

	                if (!(mPointInfo.type === POINT_TYPE_ENUM.IMG && mPointInfo.url)) {
	                  _context6.next = 10;
	                  break;
	                }

	                _context6.next = 5;
	                return this.loadImage(mPointInfo.url, filterObjByKeys(["angle", "stroke", "strokeWidth", "fill", "backgroundColor", "opacity"], mPointInfo));

	              case 5:
	                point = _context6.sent;

	                point.originX = mPointInfo.originX || 'center';
	                point.originY = mPointInfo.originY || 'center';
	                _context6.next = 39;
	                break;

	              case 10:
	                if (!(mPointInfo.type === POINT_TYPE_ENUM.TEXT && mPointInfo.text)) {
	                  _context6.next = 16;
	                  break;
	                }

	                point = new fabric.IText(mPointInfo.text, filterObjByKeys(["angle", "stroke", "strokeWidth", "fill", "fontFamily", "fontSize", "fontWeight", "fontStyle", "underline", "overline", "linethrough", "deltaY", "textBackgroundColor", "backgroundColor", "opacity"], mPointInfo));
	                point.originX = mPointInfo.originX || 'center';
	                point.originY = mPointInfo.originY || 'center';
	                _context6.next = 39;
	                break;

	              case 16:
	                if (!(mPointInfo.type === POINT_TYPE_ENUM.AREA)) {
	                  _context6.next = 25;
	                  break;
	                }

	                startPoints = mPointInfo.startPoints || [];

	                if (mPointInfo.absolute) {
	                  startPoints = startPoints.map(function (o) {
	                    var coordX = o.x / _this.svgMap.width;
	                    var coordY = o.y / _this.svgMap.height;
	                    return { coordX: coordX, coordY: coordY };
	                  });
	                }
	                clonedStartPoints = startPoints.map(function (item) {
	                  // 坐标点转换
	                  var _svgRateInfo2Point = _this.svgRateInfo2Point({ coordX: item.coordX, coordY: item.coordY }),
	                      x = _svgRateInfo2Point.x,
	                      y = _svgRateInfo2Point.y;

	                  var newPoint = _this.canvas2SvgMapPoint({ x: x, y: y });
	                  return newPoint;
	                });

	                point = new fabric.Polygon(clonedStartPoints, _extends({
	                  fill: 'transparent',
	                  stroke: 'red',
	                  strokeWidth: 2,
	                  strokeDashArray: [5, 5]
	                }, filterObjByKeys(["angle", "stroke", "strokeWidth", "fill", "strokeDashArray"], mPointInfo)));
	                point.originX = 'left';
	                point.originY = 'top';
	                _context6.next = 39;
	                break;

	              case 25:
	                if (!(mPointInfo.type === 'imgtext')) {
	                  _context6.next = 38;
	                  break;
	                }

	                image = void 0;

	                if (!(mPointInfo.image && mPointInfo.image.url)) {
	                  _context6.next = 31;
	                  break;
	                }

	                _context6.next = 30;
	                return this.loadImage(mPointInfo.image.url, mPointInfo.image);

	              case 30:
	                image = _context6.sent;

	              case 31:
	                text = void 0;

	                if (mPointInfo.text && mPointInfo.text.text) {
	                  text = new fabric.IText(mPointInfo.text.text, mPointInfo.text);
	                }
	                point = new FabricImgText(image, text, mPointInfo);
	                point.originX = mPointInfo.originX || 'center';
	                point.originY = mPointInfo.originY || 'center';
	                _context6.next = 39;
	                break;

	              case 38:
	                return _context6.abrupt('return');

	              case 39:
	                point.hasControls = false;
	                point.hasBorders = false;
	                point.lockRotation = true;
	                point.mPointInfo = Object.keys(mPointInfo).length > 0 ? mPointInfo : undefined;
	                point.mType = OBJ_POINT;
	                point.set(options);
	                point.setCoords();
	                this.initPointEvents(point);
	                return _context6.abrupt('return', point);

	              case 48:
	              case 'end':
	                return _context6.stop();
	            }
	          }
	        }, _callee6, this);
	      }));

	      function makePointImageObj() {
	        return _ref6.apply(this, arguments);
	      }

	      return makePointImageObj;
	    }(),

	    // 渲染点的信息
	    renderPoints: function () {
	      var _ref7 = asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
	        var _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, pointInfo, coordX, coordY, type, _svgRateInfo2Point2, x, y, newPoint, optionsData, pointImage;

	        return regeneratorRuntime.wrap(function _callee7$(_context7) {
	          while (1) {
	            switch (_context7.prev = _context7.next) {
	              case 0:
	                this.clearPoints();
	                // 时间戳，防止两次快速渲染，因为异步原因，导致重复渲染的问题
	                this.timestampForRenderPoints = new Date().getTime();

	                // 初始化从接口来的点
	                _iteratorNormalCompletion2 = true;
	                _didIteratorError2 = false;
	                _iteratorError2 = undefined;
	                _context7.prev = 5;
	                _iterator2 = this.mPointList[Symbol.iterator]();

	              case 7:
	                if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
	                  _context7.next = 20;
	                  break;
	                }

	                pointInfo = _step2.value;
	                coordX = pointInfo.coordX, coordY = pointInfo.coordY, type = pointInfo.type;
	                _svgRateInfo2Point2 = this.svgRateInfo2Point({ coordX: coordX, coordY: coordY }), x = _svgRateInfo2Point2.x, y = _svgRateInfo2Point2.y;
	                // 坐标点转换

	                newPoint = this.canvas2SvgMapPoint({ x: x, y: y });

	                // 多边形不需要left,top属性

	                optionsData = type === POINT_TYPE_ENUM.AREA ? {
	                  mPointInfo: pointInfo,
	                  mTimestampForRenderPoints: this.timestampForRenderPoints
	                } : {
	                  mPointInfo: pointInfo,
	                  mTimestampForRenderPoints: this.timestampForRenderPoints,
	                  left: newPoint.x,
	                  top: newPoint.y
	                };
	                _context7.next = 15;
	                return this.makePointImageObj(optionsData);

	              case 15:
	                pointImage = _context7.sent;


	                if (pointImage && pointImage.mTimestampForRenderPoints === this.timestampForRenderPoints) {
	                  this.svgMap.add(pointImage);
	                  this.canvas.requestRenderAll();
	                }

	              case 17:
	                _iteratorNormalCompletion2 = true;
	                _context7.next = 7;
	                break;

	              case 20:
	                _context7.next = 26;
	                break;

	              case 22:
	                _context7.prev = 22;
	                _context7.t0 = _context7['catch'](5);
	                _didIteratorError2 = true;
	                _iteratorError2 = _context7.t0;

	              case 26:
	                _context7.prev = 26;
	                _context7.prev = 27;

	                if (!_iteratorNormalCompletion2 && _iterator2.return) {
	                  _iterator2.return();
	                }

	              case 29:
	                _context7.prev = 29;

	                if (!_didIteratorError2) {
	                  _context7.next = 32;
	                  break;
	                }

	                throw _iteratorError2;

	              case 32:
	                return _context7.finish(29);

	              case 33:
	                return _context7.finish(26);

	              case 34:
	                this.canvas.fire('object:scaling', { target: this.svgMap });

	              case 35:
	              case 'end':
	                return _context7.stop();
	            }
	          }
	        }, _callee7, this, [[5, 22, 26, 34], [27,, 29, 33]]);
	      }));

	      function renderPoints() {
	        return _ref7.apply(this, arguments);
	      }

	      return renderPoints;
	    }(),

	    // 渲染svgmap，如果已经初始化，就销毁，重新初始化
	    renderSvgMap: function () {
	      var _ref8 = asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(svgMapUrl) {
	        return regeneratorRuntime.wrap(function _callee8$(_context8) {
	          while (1) {
	            switch (_context8.prev = _context8.next) {
	              case 0:
	                if (this.svgMap) {
	                  this.handleReloadBtnClick();
	                  this.canvas.remove(this.svgMap);
	                  this.svgMap.destroy();
	                }
	                _context8.next = 3;
	                return this.loadSvgMap(svgMapUrl);

	              case 3:
	                this.svgMap = _context8.sent;

	                this.svgMap.hasControls = false;
	                this.svgMap.hasBorders = false;
	                this.svgMap.on('mousedown', this.handleSvgMapMouseDown);
	                this.svgMap.on('mouseup', this.handleSvgMapMouseUp);
	                this.svgMap.on('mousemove', this.handleSvgMapMouseMove);
	                this.svgMap.on('scaling', this.handleSvgMapScaling); // info 通过api scale设置不会触发
	                this.svgMap.on('scaled', this.handleSvgMapScaled); // info 通过api scale设置不会触发
	                // 初始化位置
	                this.initSvgMapPosition();

	                // 重新渲染点
	                _context8.next = 14;
	                return this.renderPoints();

	              case 14:

	                this.canvas.add(this.svgMap);

	              case 15:
	              case 'end':
	                return _context8.stop();
	            }
	          }
	        }, _callee8, this);
	      }));

	      function renderSvgMap(_x7) {
	        return _ref8.apply(this, arguments);
	      }

	      return renderSvgMap;
	    }(),
	    loadSvgMap: function () {
	      var _ref9 = asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10(url) {
	        var _this2 = this;

	        return regeneratorRuntime.wrap(function _callee10$(_context10) {
	          while (1) {
	            switch (_context10.prev = _context10.next) {
	              case 0:
	                return _context10.abrupt('return', new Promise(function (resolve, reject) {
	                  fabric.loadSVGFromURL(url, function () {
	                    var _ref10 = asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(objects, options) {
	                      var obj;
	                      return regeneratorRuntime.wrap(function _callee9$(_context9) {
	                        while (1) {
	                          switch (_context9.prev = _context9.next) {
	                            case 0:
	                              obj = fabric.util.groupSVGElements(objects, _extends({}, options, {
	                                lockRotation: true,
	                                subTargetCheck: true
	                              }));

	                              resolve(obj);

	                            case 2:
	                            case 'end':
	                              return _context9.stop();
	                          }
	                        }
	                      }, _callee9, _this2);
	                    }));

	                    return function (_x9, _x10) {
	                      return _ref10.apply(this, arguments);
	                    };
	                  }());
	                }, {
	                  crossOrigin: 'anonymous'
	                }));

	              case 1:
	              case 'end':
	                return _context10.stop();
	            }
	          }
	        }, _callee10, this);
	      }));

	      function loadSvgMap(_x8) {
	        return _ref9.apply(this, arguments);
	      }

	      return loadSvgMap;
	    }(),

	    // 根据屏幕大小，缩放到全部内容可以整个屏幕展示
	    initSvgMapPosition: function initSvgMapPosition() {
	      var parentEl = this.$el.querySelector('.fm-map-wrapper');
	      var clientWidth = parentEl.clientWidth;
	      var clientHeight = parentEl.clientHeight;
	      var defaultScale = Math.min(clientWidth / this.svgMap.width, clientHeight / this.svgMap.height).toFixed(1);
	      this.svgMap.scale(defaultScale);
	      this.svgMap.top = Math.floor(clientHeight / 2 - this.svgMap.getScaledHeight() / 2);
	      this.svgMap.left = Math.floor(clientWidth / 2 - this.svgMap.getScaledWidth() / 2);
	      this.svgMap.setCoords();
	      this.canvas.fire('object:scaling', { target: this.svgMap });
	      this.svgMap.fire('scaling');
	    },
	    loadImage: function () {
	      var _ref11 = asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11(imageUrl, options) {
	        return regeneratorRuntime.wrap(function _callee11$(_context11) {
	          while (1) {
	            switch (_context11.prev = _context11.next) {
	              case 0:
	                return _context11.abrupt('return', new Promise(function (resolve, reject) {
	                  fabric.Image.fromURL(imageUrl, function (img) {
	                    resolve(img);
	                  }, options);
	                }));

	              case 1:
	              case 'end':
	                return _context11.stop();
	            }
	          }
	        }, _callee11, this);
	      }));

	      function loadImage(_x11, _x12) {
	        return _ref11.apply(this, arguments);
	      }

	      return loadImage;
	    }(),
	    limitActivePointPosition: function limitActivePointPosition() {
	      if (!this.svgMap) return;
	      if (!this.activePoint) return;
	      // 参考 https://codepen.io/elifitch/pen/RPEEOJ
	      var movingBox = this.activePoint;
	      var boundingBox = this.svgMap;
	      var topBound = boundingBox.top;
	      var bottomBound = topBound + boundingBox.getScaledHeight();
	      var leftBound = boundingBox.left;
	      var rightBound = leftBound + boundingBox.getScaledWidth();
	      var movingBoxWidth = movingBox.getScaledWidth();
	      var movingBoxHeight = movingBox.getScaledHeight();
	      if (movingBox.originX === 'center') {
	        movingBox.left = Math.min(Math.max(movingBox.left, leftBound + movingBoxWidth / 2), rightBound - movingBoxHeight / 2);
	      } else if (movingBox.originX === 'left') {
	        movingBox.left = Math.min(Math.max(movingBox.left, leftBound), rightBound - movingBoxHeight);
	      }
	      if (movingBox.originY === 'bottom') {
	        movingBox.top = Math.min(Math.max(movingBox.top, topBound + movingBoxHeight), bottomBound);
	      } else if (movingBox.originY === 'top') {
	        movingBox.top = Math.min(Math.max(movingBox.top, topBound), bottomBound - movingBoxHeight);
	      } else if (movingBox.originY === 'center') {
	        movingBox.top = Math.min(Math.max(movingBox.top, topBound + movingBoxHeight / 2), bottomBound - movingBoxHeight / 2);
	      }
	      movingBox.setCoords();
	      this.canvas.requestRenderAll();
	    },

	    // 记住图和点的矩阵关系
	    rememberRelationShip: function rememberRelationShip() {
	      if (this.activePoint && this.svgMap) {
	        var bossTransform = this.svgMap.calcTransformMatrix();
	        var invertedBossTransform = fabric.util.invertTransform(bossTransform);
	        this.activePoint.relationship = fabric.util.multiplyTransformMatrices(invertedBossTransform, this.activePoint.calcTransformMatrix());
	      }
	    },

	    // 限制点
	    updateMinions: function updateMinions() {
	      if (this.activePoint && this.svgMap && this.activePoint.relationship) {
	        var o = this.activePoint;
	        var boss = this.svgMap;
	        var relationship = o.relationship;
	        var newTransform = fabric.util.multiplyTransformMatrices(boss.calcTransformMatrix(), relationship);
	        var opt = fabric.util.qrDecompose(newTransform);
	        o.set({
	          flipX: false,
	          flipY: false
	        });
	        o.setPositionByOrigin({ x: opt.translateX, y: opt.translateY }, 'center', 'center');
	        o.set(opt);
	        o.setCoords();
	      }
	    },
	    handleCanvasMouseDown: function handleCanvasMouseDown(opt) {
	      opt.e && opt.e.stopPropagation();
	      this.canvas.discardActiveObject();
	      this.rememberRelationShip();
	    },
	    handleCanvasScaling: function handleCanvasScaling(e) {
	      if (this.scalingMinion) this.updateMinions();
	      this.limitActivePointPosition();
	    },
	    handleCanvasMoving: function handleCanvasMoving(opt) {
	      opt.e && opt.e.stopPropagation();
	      if (opt.target === this.svgMap) {
	        if (this.movingMinion) this.updateMinions();
	      }
	      this.updatePointLine();
	      this.limitActivePointPosition();
	    },
	    handleCanvasMouseUp: function handleCanvasMouseUp(opt) {
	      if (this.selectedPoint && !opt.target) {
	        this.selectedPoint = null;
	        this.clearLine();
	      }
	      this.rememberRelationShip();
	    },
	    handleSvgMapMouseUp: function () {
	      var _ref12 = asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12(opt) {
	        var _invertPointer, x, y, pointImage;

	        return regeneratorRuntime.wrap(function _callee12$(_context12) {
	          while (1) {
	            switch (_context12.prev = _context12.next) {
	              case 0:
	                if (!(this.svgMap.left === this.mouseDownSvgMapPointer.left && this.svgMap.top === this.mouseDownSvgMapPointer.top)) {
	                  _context12.next = 11;
	                  break;
	                }

	                // 如果进入点击状态，取消选中状态WW
	                if (this.selectedPoint) {
	                  this.selectedPoint = null;
	                  this.clearLine();
	                }
	                // 只有在进入到可点击状态才能允许放入位置点

	                if (!(!this.addTipInfoShow && !this.readyPointInfo)) {
	                  _context12.next = 4;
	                  break;
	                }

	                return _context12.abrupt('return');

	              case 4:
	                this.addTipInfoShow = false;
	                _invertPointer = this.invertPointer(opt.pointer), x = _invertPointer.x, y = _invertPointer.y;
	                _context12.next = 8;
	                return this.makePointImageObj({
	                  left: x,
	                  top: y,
	                  mPointInfo: this.readyPointInfo
	                });

	              case 8:
	                pointImage = _context12.sent;

	                this.readyPointInfo = null;
	                if (pointImage) {
	                  this.canvas.add(pointImage);
	                  this.canvas.bringToFront(pointImage);
	                  this.selectedPoint = null;
	                  this.activePoint = pointImage;
	                  this.updatePointLine(); // 强制更新线条，并且接口第一次点击偶尔会不显示图标的问题
	                }

	              case 11:
	              case 'end':
	                return _context12.stop();
	            }
	          }
	        }, _callee12, this);
	      }));

	      function handleSvgMapMouseUp(_x13) {
	        return _ref12.apply(this, arguments);
	      }

	      return handleSvgMapMouseUp;
	    }(),
	    handleSvgMapMouseDown: function handleSvgMapMouseDown(opt) {
	      opt.e && opt.e.stopPropagation();
	      // 备份点击状态下的位置，用于判断move状态还是click状态
	      this.mouseDownSvgMapPointer = { left: this.svgMap.left, top: this.svgMap.top };
	      if (this.activePoint) {
	        this.updatePointLine();
	      }
	    },
	    handleSvgMapMouseMove: function handleSvgMapMouseMove(opt) {
	      opt.e && opt.e.stopPropagation();
	    },
	    handleSvgMapScaling: function handleSvgMapScaling(opt) {
	      this.updatePointLine();
	    },
	    handleSvgMapScaled: function handleSvgMapScaled() {
	      this.updatePointLine();
	    },
	    initPointEvents: function initPointEvents(point) {
	      var self = this;
	      point.on('mousedown', function (opt) {
	        opt.e && opt.e.stopPropagation();
	      });
	      point.on('mousemove', function (opt) {
	        opt.e && opt.e.stopPropagation();
	        self.updatePointLine();
	      });
	      point.on('mouseup', function (opt) {
	        if (!self.activePoint) {
	          self.selectedPoint = point;
	        }
	      });
	    },
	    removeActivePoint: function removeActivePoint() {
	      if (this.activePoint) {
	        this.canvas.remove(this.activePoint);
	        this.clearLine();
	        this.activePoint = null;
	      }
	    },
	    removeSelectPoint: function removeSelectPoint() {
	      if (this.selectedPoint) {
	        this.svgMap.remove(this.selectedPoint);
	        this.clearLine();
	        this.selectedPoint = null;
	      }
	    },
	    addActivePointToSvgMap: function addActivePointToSvgMap() {
	      if (this.activePoint) {
	        var scaleX = this.svgMap.scaleX;

	        var newPoint = this.canvas2SvgMapPoint({ x: this.activePoint.left, y: this.activePoint.top });

	        this.activePoint.scale(1);
	        this.activePoint.left = newPoint.x;
	        this.activePoint.top = newPoint.y;
	        this.activePoint.setCoords();
	        // 加入到group中
	        this.svgMap.add(this.activePoint);
	      }
	    },
	    handleAddPointBtnClick: function handleAddPointBtnClick() {
	      this.editPointInfo = undefined;
	      this.formShow = true;
	    },
	    handleDelBtnClick: function () {
	      var _ref13 = asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee13() {
	        var point;
	        return regeneratorRuntime.wrap(function _callee13$(_context13) {
	          while (1) {
	            switch (_context13.prev = _context13.next) {
	              case 0:
	                point = this.activePoint || this.selectedPoint;

	                if (!point) {
	                  _context13.next = 8;
	                  break;
	                }

	                _context13.t0 = point.mPointInfo;

	                if (!_context13.t0) {
	                  _context13.next = 6;
	                  break;
	                }

	                _context13.next = 6;
	                return this.callFun('deleteCb', point.mPointInfo);

	              case 6:
	                this.removeActivePoint();
	                this.removeSelectPoint();

	              case 8:
	              case 'end':
	                return _context13.stop();
	            }
	          }
	        }, _callee13, this);
	      }));

	      function handleDelBtnClick() {
	        return _ref13.apply(this, arguments);
	      }

	      return handleDelBtnClick;
	    }(),
	    handleEditBtnClick: function handleEditBtnClick() {
	      var point = this.activePoint || this.selectedPoint;
	      if (point && point.mPointInfo) {
	        this.editPointInfo = point.mPointInfo;
	        this.formShow = true;
	      }
	    },

	    // 当canvas画布本身进行了变化，事件的点坐标也需要进行变换
	    invertPointer: function invertPointer() {
	      var _ref14 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
	          x = _ref14.x,
	          y = _ref14.y;

	      var mInverse = fabric.util.invertTransform(this.canvas.viewportTransform);
	      var newPoint = fabric.util.transformPoint({ x: x, y: y }, mInverse);
	      return newPoint;
	    },

	    // 获取相对于svg图的比例坐标
	    point2svgRelativeRateInfo: function point2svgRelativeRateInfo() {
	      var _ref15 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
	          x = _ref15.x,
	          y = _ref15.y;

	      var absoulte = arguments[1];

	      if (absoulte) {
	        // canvas viewport发生变换，也需要反向计算出基于canvas变换后新的位置
	        var mInverse = fabric.util.invertTransform(this.canvas.viewportTransform);
	        var newPoint = fabric.util.transformPoint({ x: x, y: y }, mInverse);
	        x = newPoint.x;
	        y = newPoint.y;
	      }
	      var coordY = (y - this.svgMap.top) / this.svgMap.getScaledHeight();
	      var coordX = (x - this.svgMap.left) / this.svgMap.getScaledWidth();
	      return { coordX: coordX, coordY: coordY };
	    },

	    // svg图的比例坐标转换成canvas坐标点
	    svgRateInfo2Point: function svgRateInfo2Point() {
	      var _ref16 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
	          coordX = _ref16.coordX,
	          coordY = _ref16.coordY;

	      var absoulte = arguments[1];

	      if (!this.svgMap) return {};
	      var x = Math.round(coordX * this.svgMap.getScaledWidth() + this.svgMap.left);
	      var y = Math.round(coordY * this.svgMap.getScaledHeight() + this.svgMap.top);
	      // canvas viewport发生变换，也需要计算出基于canvas变换后新的位置
	      if (absoulte) {
	        var newPoint = fabric.util.transformPoint({ x: x, y: y }, this.canvas.viewportTransform);
	        x = Math.floor(newPoint.x);
	        y = Math.floor(newPoint.y);
	      }
	      return { x: x, y: y };
	    },

	    // 保存节点
	    savePoint: function () {
	      var _ref17 = asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee14() {
	        var point, isInSvgMap, left, top, newPoint, _point2svgRelativeRat, coordX, coordY, _point$mPointInfo, mPointInfo, res;

	        return regeneratorRuntime.wrap(function _callee14$(_context14) {
	          while (1) {
	            switch (_context14.prev = _context14.next) {
	              case 0:
	                point = this.activePoint || this.selectedPoint;
	                isInSvgMap = point === this.selectedPoint;
	                left = point.left, top = point.top;

	                if (isInSvgMap) {
	                  newPoint = this.svgMap2CanvasPoint({ x: point.left, y: point.top });

	                  left = newPoint.x;
	                  top = newPoint.y;
	                }
	                _point2svgRelativeRat = this.point2svgRelativeRateInfo({ x: left, y: top }), coordX = _point2svgRelativeRat.coordX, coordY = _point2svgRelativeRat.coordY;
	                _point$mPointInfo = point.mPointInfo, mPointInfo = _point$mPointInfo === undefined ? {} : _point$mPointInfo;
	                _context14.next = 8;
	                return this.savePointInfo(_extends({}, mPointInfo, {
	                  coordX: coordX,
	                  coordY: coordY
	                }));

	              case 8:
	                res = _context14.sent;

	              case 9:
	              case 'end':
	                return _context14.stop();
	            }
	          }
	        }, _callee14, this);
	      }));

	      function savePoint() {
	        return _ref17.apply(this, arguments);
	      }

	      return savePoint;
	    }(),
	    handleUnLockBtnClick: function () {
	      var _ref18 = asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee15() {
	        return regeneratorRuntime.wrap(function _callee15$(_context15) {
	          while (1) {
	            switch (_context15.prev = _context15.next) {
	              case 0:
	                if (!this.activePoint) {
	                  _context15.next = 4;
	                  break;
	                }

	                _context15.next = 3;
	                return this.savePoint();

	              case 3:
	                // 如果处于活跃状态，就绑定
	                // this.addActivePointToSvgMap()
	                this.removeActivePoint();

	              case 4:
	              case 'end':
	                return _context15.stop();
	            }
	          }
	        }, _callee15, this);
	      }));

	      function handleUnLockBtnClick() {
	        return _ref18.apply(this, arguments);
	      }

	      return handleUnLockBtnClick;
	    }(),

	    // 选中点与地图解绑，之后可以拖动移动
	    handleLockBtnClick: function handleLockBtnClick() {
	      if (this.selectedPoint) {
	        this.svgMap.remove(this.selectedPoint);
	        this.activePoint = this.selectedPoint;
	        this.selectedPoint = null;
	        var point = this.activePoint;
	        point.hasControls = false;
	        point.hasBorders = false;
	        point.lockRotation = true;
	        var newPoint = this.svgMap2CanvasPoint({ x: point.left, y: point.top });
	        point.leftBackup = newPoint.x;
	        point.topBackup = newPoint.y;
	        point.left = newPoint.x;
	        point.top = newPoint.y;
	        point.scale(this.svgMap.scaleX);
	        point.setCoords();
	        this.canvas.add(point);
	      }
	    },
	    handleDirBtnClick: function handleDirBtnClick(direction) {
	      var obj = this.activePoint || this.selectedPoint;
	      if (direction === 'up') {
	        obj.top -= 1;
	      } else if (direction === 'down') {
	        obj.top += 1;
	      } else if (direction === 'left') {
	        obj.left -= 1;
	      } else if (direction === 'right') {
	        obj.left += 1;
	      }
	      if (obj === this.selectedPoint) {
	        // 更新group中的对象的位置，不会触发更新，故先删除再添加保证能够出发更新，不过因为没有边界判定，可能出现越界问题
	        this.svgMap.remove(obj);
	        this.svgMap.add(obj); // 可能超出边界
	      }
	      this.canvas.fire('object:moving', { target: obj });
	      this.updatePointLine();
	    },
	    handleReloadBtnClick: function handleReloadBtnClick() {
	      if (this.svgMap) {
	        if (this.activePoint) {
	          if (this.activePoint.leftBackup && this.activePoint.topBackup) {
	            this.canvas.remove(this.activePoint);
	            this.activePoint.left = this.activePoint.leftBackup;
	            this.activePoint.top = this.activePoint.topBackup;
	            this.addActivePointToSvgMap();
	          } else {
	            this.canvas.remove(this.activePoint);
	          }
	          this.activePoint = null;
	        }
	        this.selectedPoint = null;
	        this.clearLine();
	        this.canvas.viewportTransform = [1, 0, 0, 1, 0, 0];
	        this.initSvgMapPosition();
	        this.canvas.requestRenderAll();
	      }
	    },

	    // canvas中的点转换到svg图中的相对位置点
	    // 转换到group中坐标 参考https://github.com/nqdy666/Fabric-Tutorial_zh-CN/blob/master/part-6.md
	    canvas2SvgMapPoint: function canvas2SvgMapPoint() {
	      var _ref19 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
	          x = _ref19.x,
	          y = _ref19.y;

	      if (!this.svgMap) return {};
	      var matrix = this.svgMap.calcTransformMatrix();
	      var invertMatrix = fabric.util.invertTransform(matrix);
	      return fabric.util.transformPoint({ x: x, y: y }, invertMatrix);
	    },

	    // svgMap中相对位置的点转换到canvas中
	    svgMap2CanvasPoint: function svgMap2CanvasPoint() {
	      var _ref20 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
	          x = _ref20.x,
	          y = _ref20.y;

	      var matrix = this.svgMap.calcTransformMatrix();
	      var newP = fabric.util.transformPoint({ x: x, y: y }, matrix);
	      return newP;
	    }
	  }
	};

	/* script */
	var __vue_script__$5 = script$5;

	/* template */
	var __vue_render__$5 = function __vue_render__() {
	  var _vm = this;
	  var _h = _vm.$createElement;
	  var _c = _vm._self._c || _h;
	  return _c("div", {
	    staticClass: "fm-svg-map-wrapper",
	    style: { "background-color": _vm.backgroundColor }
	  }, [_vm._m(0), _vm._v(" "), _vm.showOp ? _c("div", [_c("div", { staticClass: "fm-zoom-btn-wrapper" }, [_c("i", {
	    staticClass: "fm-icon-plus",
	    on: { click: _vm.handleZoomOutBtnClick }
	  }), _vm._v(" "), _c("i", {
	    staticClass: "fm-icon-minus",
	    on: { click: _vm.handleZoomInBtnClick }
	  })]), _vm._v(" "), _c("div", {
	    directives: [{
	      name: "show",
	      rawName: "v-show",
	      value: _vm.showAddPointBtn,
	      expression: "showAddPointBtn"
	    }],
	    staticClass: "fm-add-btn-wrapper"
	  }, [_c("i", {
	    staticClass: "fm-icon-plus-circle",
	    on: { click: _vm.handleAddPointBtnClick }
	  })]), _vm._v(" "), _c("div", {
	    directives: [{
	      name: "show",
	      rawName: "v-show",
	      value: _vm.showOpBtnWrapper,
	      expression: "showOpBtnWrapper"
	    }],
	    staticClass: "fm-op-btn-wrapper"
	  }, [_c("i", {
	    directives: [{
	      name: "show",
	      rawName: "v-show",
	      value: _vm.showEditBtn,
	      expression: "showEditBtn"
	    }],
	    staticClass: "fm-icon-edit",
	    on: { click: _vm.handleEditBtnClick }
	  }), _vm._v(" "), _c("i", {
	    directives: [{
	      name: "show",
	      rawName: "v-show",
	      value: _vm.showDeleteBtn,
	      expression: "showDeleteBtn"
	    }],
	    staticClass: "fm-icon-delete",
	    on: { click: _vm.handleDelBtnClick }
	  }), _vm._v(" "), _vm.showLockBtn ? _c("i", {
	    directives: [{
	      name: "show",
	      rawName: "v-show",
	      value: _vm.lockBtn,
	      expression: "lockBtn"
	    }],
	    staticClass: "fm-icon-lock",
	    on: { click: _vm.handleLockBtnClick }
	  }) : _vm._e(), _vm._v(" "), _vm.showLockBtn ? _c("i", {
	    directives: [{
	      name: "show",
	      rawName: "v-show",
	      value: !_vm.lockBtn,
	      expression: "!lockBtn"
	    }],
	    staticClass: "fm-icon-unlock",
	    on: { click: _vm.handleUnLockBtnClick }
	  }) : _vm._e()]), _vm._v(" "), _c("dir-btn", {
	    directives: [{
	      name: "show",
	      rawName: "v-show",
	      value: _vm.showDirBtn,
	      expression: "showDirBtn"
	    }],
	    on: { change: _vm.handleDirBtnClick }
	  }), _vm._v(" "), _c("div", {
	    directives: [{
	      name: "show",
	      rawName: "v-show",
	      value: _vm.addTipInfoShow,
	      expression: "addTipInfoShow"
	    }],
	    staticClass: "fm-add-tip-wrapper"
	  }, [_c("p", [_vm._v("请在地图中点击以添加点")])]), _vm._v(" "), _c("div", { staticClass: "fm-reload-wrapper" }, [_c("i", {
	    staticClass: "fm-icon-reload",
	    on: { click: _vm.handleReloadBtnClick }
	  })]), _vm._v(" "), _vm.formShow ? _c("fm-form", {
	    attrs: { data: _vm.editPointInfo },
	    on: {
	      close: function close($event) {
	        _vm.formShow = false;
	      },
	      submit: _vm.handleFormSubmit
	    }
	  }) : _vm._e()], 1) : _vm._e()]);
	};
	var __vue_staticRenderFns__$5 = [function () {
	  var _vm = this;
	  var _h = _vm.$createElement;
	  var _c = _vm._self._c || _h;
	  return _c("div", { staticClass: "fm-map-wrapper" }, [_c("canvas", { staticClass: "fm-m-canvas", attrs: { id: "map-canvas" } })]);
	}];
	__vue_render__$5._withStripped = true;

	/* style */
	var __vue_inject_styles__$5 = undefined;
	/* scoped */
	var __vue_scope_id__$5 = undefined;
	/* module identifier */
	var __vue_module_identifier__$5 = undefined;
	/* functional template */
	var __vue_is_functional_template__$5 = false;
	/* component normalizer */
	function __vue_normalize__$5(template, style, script, scope, functional, moduleIdentifier, createInjector, createInjectorSSR) {
	  var component = (typeof script === 'function' ? script.options : script) || {};

	  // For security concerns, we use only base name in production mode.
	  component.__file = "D:\\Workspaces\\fabirc-map-vue\\src\\components\\fabric-map-vue\\fabric-map-vue.vue";

	  if (!component.render) {
	    component.render = template.render;
	    component.staticRenderFns = template.staticRenderFns;
	    component._compiled = true;

	    if (functional) component.functional = true;
	  }

	  component._scopeId = scope;

	  return component;
	}
	/* style inject */

	/* style inject SSR */

	var fabricMapVue = __vue_normalize__$5({ render: __vue_render__$5, staticRenderFns: __vue_staticRenderFns__$5 }, __vue_inject_styles__$5, __vue_script__$5, __vue_scope_id__$5, __vue_is_functional_template__$5, __vue_module_identifier__$5, undefined, undefined);

	/**
	 * Register a component plugin as being loaded. returns true if compoent plugin already registered
	 * @param {object} Vue
	 * @param {string} Component name
	 * @param {object} Component definition
	 */
	function registerComponent(Vue, name, def) {
	  Vue._fm_components_installed = Vue._fm_components_installed || {};
	  var loaded = Vue._fm_components_installed[name];
	  if (!loaded && def && name) {
	    Vue._fm_components_installed[name] = true;
	    Vue.component(name, def);
	  }
	  return loaded;
	}

	/**
	 * Register a group of components as being loaded.
	 * @param {object} Vue
	 * @param {object} Object of component definitions
	 */
	function registerComponents(Vue, components) {
	  for (var component in components) {
	    registerComponent(Vue, component, components[component]);
	  }
	}

	/**
	 * Install plugin if window.Vue available
	 * @param {object} Plugin definition
	 */
	function vueUse(VuePlugin) {
	  if (typeof window !== 'undefined' && window.Vue) {
	    window.Vue.use(VuePlugin);
	  }
	}

	var components = {
	  fabricMapVue: fabricMapVue
	};

	var VuePlugin = {
	  install: function install(Vue) {
	    registerComponents(Vue, components);
	  }
	};

	vueUse(VuePlugin);



	var components$1 = /*#__PURE__*/Object.freeze({
		FabircMapVue: VuePlugin
	});

	var VuePlugin$1 = {
	  install: function install(Vue) {
	    if (Vue._fabric_map_vue) {
	      return;
	    }
	    Vue._fabric_map_vue = true;

	    // Register component plugins
	    for (var plugin in components$1) {
	      Vue.use(components$1[plugin]);
	    }
	  }
	};

	vueUse(VuePlugin$1);

	return VuePlugin$1;

})));
//# sourceMappingURL=fabric-map-vue.js.map
