var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEFAULT_OPTIONS = {
  selectable: false,
  strokeWidth: 2,
  evented: false,
  stroke: 'red',
  text: '',
  textStyle: 'red'
  // strokeDashArray: [5, 5],
};

var FabricArrowLine = function (_fabric$Line) {
  _inherits(FabricArrowLine, _fabric$Line);

  function FabricArrowLine(points) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, FabricArrowLine);

    return _possibleConstructorReturn(this, (FabricArrowLine.__proto__ || Object.getPrototypeOf(FabricArrowLine)).call(this, points, _extends({}, DEFAULT_OPTIONS, options)));
  }
  // 获取线的长度


  _createClass(FabricArrowLine, [{
    key: 'getLength',
    value: function getLength() {
      var p = this.calcLinePoints();
      var xDiff = p.x2 - p.x1;
      var yDiff = p.y2 - p.y1;
      return Math.sqrt(Math.pow(xDiff, 2) + Math.pow(yDiff, 2));
    }
  }, {
    key: '_render',
    value: function _render(ctx) {
      _get(FabricArrowLine.prototype.__proto__ || Object.getPrototypeOf(FabricArrowLine.prototype), '_render', this).call(this, ctx);
      // 若果不显示或者坐标是一个点就不画箭头和文字
      var p = this.calcLinePoints();
      var xDiff = p.x2 - p.x1;
      var yDiff = p.y2 - p.y1;
      if (!this.visible || !xDiff && !yDiff) return;

      var angle = Math.atan2(yDiff, xDiff);

      ctx.strokeStyle = this.stroke;
      if (this.strokeDashArray) {
        ctx.setLineDash(this.strokeDashArray);
      }

      // 画开始箭头
      ctx.save();
      ctx.translate((p.x2 - p.x1) / 2, (p.y2 - p.y1) / 2);
      ctx.rotate(angle);
      ctx.moveTo(-8, 8);
      ctx.lineTo(0, 0);
      ctx.lineTo(-8, -8);
      ctx.stroke();
      ctx.restore();

      // 画结束箭头
      ctx.save();
      ctx.translate(-(p.x2 - p.x1) / 2, -(p.y2 - p.y1) / 2);
      ctx.rotate(angle);
      ctx.moveTo(8, 8);
      ctx.lineTo(0, 0);
      ctx.lineTo(8, -8);
      ctx.stroke();
      ctx.restore();
      // 添加文字
      ctx.save();
      // 保证文字从左至右，且下到上
      ctx.rotate(xDiff > 0 ? Math.atan2(yDiff, xDiff) : Math.atan2(-yDiff, -xDiff));

      // 绘制文字，放在点的起始位置
      ctx.fillStyle = this.textStyle;
      ctx.textAlign = xDiff <= 0 ? 'left' : 'right';
      ctx.fillText(this.text, 0, -10);
      ctx.restore();
    }
  }]);

  return FabricArrowLine;
}(fabric.Line);

export default FabricArrowLine;